#define gcc 1
#if gcc
#include <stdio.h>
#include <time.h>
#else
#include "..\include\time.h"
#include "..\include\stdio.h"
#endif

int ch = 0;
int ch_look_ahead = 0;

int identifier_length_limit = 128;
int scanned_identifier_length;
int scanned_identifier[129];
int scanned_identifier_index;

int scanned_string_limit = 1000;
int scanned_string_length;
int scanned_string[1000];
int scanned_constant_value;

/*
1 initial identifier A-Z a-z _ $
2 internal indentifier A-Z a-z _ $ 0-9
4 whitespace space tab cr lf vt ff
8 operator ! " % ' ( ) * + , - / ;  : < = > [ ] { | } # $
16 number 0-9
32 hex number A-F a-f 0-9
64 escape
*/
int character_type_map[128]  = {
			       0,0,0,0,0,0,0,0,0,4,4,4,4,4,0,0,
			       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
			       4,8,8,8,3,8,8,8,8,8,8,8,8,8,0,8,
			       50,50,50,50,50,50,50,50,50,50,8,8,8,8,8,8,
			       0,35,35,35,35,35,35,3,3,3,3,3,3,3,3,3,
			       3,3,3,3,3,3,3,3,3,3,3,8,64,8,0,3,
			       0,35,35,35,35,35,35,3,3,3,3,3,3,3,3,3,
			       3,3,3,3,3,3,3,3,3,3,3,8,8,8,0,0,
                               };

int character_operator_map[128]  = {
	                           0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
				   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
				   0,1,44,0,0,21,3,0,5,6,7,8,9,10,0,11,
				   0,0,0,0,0,0,0,0,0,0,4,12,13,14,15,2,
				   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
				   0,0,0,0,0,0,0,0,0,0,0,16,0,17,0,0,
				   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
				   0,0,0,0,0,0,0,0,0,0,0,18,19,20,0,0,
                                 };


					    


int next_string_list = 73;
int string_list_limit = 1000;
int symbol_string_list[1000] =
                    {'0',
                     /* 1 */
	             'b','r','e','a','k',0,
		     /* 7 */
	             'c','a','s','e',0,
		     /* 12 */
		     'c','o','n','t','i','n','u','e',0,
		     /* 21 */
		     'd','e','f','a','u','l','t',0,
		     /* 29 */
		     'd','o',0,
		     /* 32 */
		     'e','l','s','e',0,
		     /* 37 */
		     'f','o','r',0,
		     /* 41 */
		     'g','o','t','o',0,
		     /* 46 */
		     'i','f',0,
		     /* 49 */
		     'i','n','t',0,
		     /* 53 */
		     'r','e','t','u','r','n',0,
		     /* 60 */
		     's','w','i','t','c','h',0,
		     /* 67 */
		     'w','h','i','l','e',0,
		     /* 73 */
		    };

char * token_map[] ={"null", "!", "?", "&", ":", "(", ")", "*", "+", ",",
                    "-", "/", ";", "<", "=", ">", "[", "]", "{", "|",
		    "}", "%", ">>", "<<", ">=", "<=", "!=", "==", "<constant>", "<string>",
		    "<identifier>", "break", "case", "continue", "default", "do", "else", "for", "goto", "if",
		    "int", "return", "switch", "while", "#",};


int symbol_index_limit = 256;
int next_symbol_index = 13;
int symbol_string_list_index[256] =
                    { 1, 7, 12, 21, 29, 32, 37, 41, 46, 49, 53, 60, 67, };
int symbol_sorted_order[256] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, };
int symbol_value_1[256] =
                    { 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43,};
int symbol_value_2[256] =
                    {0,0,0,0,0,0,0,0,0,0,0,0,0,};

#define EMPTY (-1)
#define EXHAUSTED (-2)
#define NONTERMINAL (256)

#define TRUE (1==1)
#define FALSE (1==0)


int parse_table_token[] = {
	                    /* 0 */
	                    0,
			    3,
			    EXHAUSTED,
			    NONTERMINAL+7,
			    EXHAUSTED,
			    3,
			    EXHAUSTED,
			    30,
			    EXHAUSTED,
			    14,
			    /* 10 */
			    EXHAUSTED,
			    NONTERMINAL+13,
			    EXHAUSTED,
			    NONTERMINAL+35,
			    NONTERMINAL+16,
			    EXHAUSTED,
			    NONTERMINAL+22,
			    EXHAUSTED,
			    8,
			    EMPTY,
			    /* 20 */
			    NONTERMINAL+22,
			    EXHAUSTED,
			    NONTERMINAL+28,
			    EXHAUSTED,
			    7,
			    EMPTY,
			    NONTERMINAL+28,
			    EXHAUSTED,
			    30,
			    5,
			    /* 30 */
			    EXHAUSTED,
			    NONTERMINAL+16,
			    EXHAUSTED,
			    6,
			    EXHAUSTED,
			    NONTERMINAL+41,
			    EXHAUSTED,
			    36,
			    EMPTY,
			    NONTERMINAL+16,
			    /* 40 */
			    EXHAUSTED,
			    39,
			    EXHAUSTED,
			    NONTERMINAL+49,
			    EXHAUSTED,
			    33,
			    EXHAUSTED,
			    NONTERMINAL+16,
			    EXHAUSTED,
			    NONTERMINAL+16,
			    /* 50 */
			    EXHAUSTED,
			    27,
			    15,
			    24,
			    EXHAUSTED,
			    NONTERMINAL+16,
			    EXHAUSTED,
			    NONTERMINAL+16,
			    EXHAUSTED,
			    NONTERMINAL+16,
			    /* 60 */
			    EXHAUSTED,

                          };

int parse_table_control[] = {
	                      /* 0 */
	                      0,
			      3,
			      0,
			      5,
			      0,
			      EMPTY,
			      0,
			      9,
			      0,
			      11,
			      /* 10 */
			      0,
			      EMPTY,
			      0,
			      EMPTY,
			      EMPTY,
			      0,
			      18,
			      0,
			      20,
			      EMPTY,
			      /* 20 */
			      18,
			      0,
			      24,
			      0,
			      26,
			      EMPTY,
			      24,
			      0,
			      EMPTY,
			      31,
			      /* 30 */
			      0,
			      33,
			      0,
			      EMPTY,
			      0,
			      37,
			      0,
			      39,
			      EMPTY,
			      EMPTY,
			      /* 40 */
			      0,
			      43,
			      0,
			      45,
			      0,
			      47,
			      0,
			      EMPTY,
			      0,
			      51,
			      /* 50 */
			      0,
			      55,
			      57,
			      59,
			      0,
			      EMPTY,
			      0,
			      EMPTY,
			      0,
			      EMPTY,
			      /* 60 */
			      0,

		            };
int parse_table_action[] = {
	                      /* 0 */
	                      0,
			      EMPTY,
			      0,
			      EMPTY,
			      0,
			      EMPTY,
			      0,
			      1,
			      0,
			      EMPTY,
			      /* 10 */
			      0,
			      2,
			      0,
			      EMPTY,
			      EMPTY,
			      0,
			      EMPTY,
			      0,
			      EMPTY,
			      EMPTY,
			      /* 20 */
			      3,
			      0,
			      EMPTY,
			      0,
			      EMPTY,
			      EMPTY,
			      4,
			      0,
			      5,
			      EMPTY,
			      /* 30 */
			      0,
			      EMPTY,
			      0,
			      EMPTY,
			      0,
			      EMPTY,
			      0,
			      EMPTY,
			      EMPTY,
			      8,
			      /* 40 */
			      0,
			      EMPTY,
			      0,
			      6,
			      0,
			      EMPTY,
			      0,
			      7,
			      0,
			      EMPTY,
			      /* 50 */
			      0,
			      EMPTY,
			      EMPTY,
			      EMPTY,
			      0,
			      9,
			      0,
			      10,
			      0,
			      11,
			      /* 60 */
			      0,


		           };
int parse_table_data[] = {
	                      /* 0 */
	                      0,
		           };
int parse_stack_limit = 100;
int parse_stack;
int parse_table;
int parse_stack_state[100],parse_stack_value1[100],parse_stack_value2[100];


void parse_table_check();

int main(){
/*	compile(); */
/* parse_table_check();*/ 
for (; conway_parser() == 0;);
return(0);
}

void parse_table_check()
{
int i,len;
printf("token list entries: %d\n", sizeof(parse_table_token)/sizeof(int) - 1);
printf("control list entries: %d\n", sizeof(parse_table_control)/sizeof(int) - 1);
printf("action list entries: %d\n", sizeof(parse_table_action)/sizeof(int) - 1);

len = sizeof(parse_table_token) > sizeof(parse_table_control)?sizeof(parse_table_control) : sizeof(parse_table_token);
len = len > sizeof(parse_table_action)?sizeof(parse_table_action):len;
len = len/sizeof(int);

for(i=1;i < len; i++)
 {

  printf("%3d | ", i);

  if(parse_table_token[i] == EXHAUSTED) printf(" EXHAUSTED    ");
  else
  if(parse_table_token[i] == EMPTY)     printf(" EMPTY        ");
    else
     if(parse_table_token[i] < NONTERMINAL) printf("%12s  ",token_map[parse_table_token[i]]);
  else
  printf("nonterm%3d    ",parse_table_token[i] - NONTERMINAL);

 printf("|");

 if(parse_table_action[i] == 0)     printf("            ");
 else
 if(parse_table_action[i] == EMPTY) printf(" EMPTY      ");
 else
 printf                                   (" action %3d ",parse_table_action[i]);

printf("|");

  if(parse_table_control[i] == 0)       printf("                ");
   else
    if(parse_table_control[i] == EMPTY) printf("          EMPTY ");
     else
      printf                                  (" next state %3d ",parse_table_control[i]);


 printf("|\n");

 };

}

int compile(){
	int token;
	int i,k,m;

/*	if ((token = scan()) == EOF)return(0); */

for(parse_stack = 0,parse_table = 0;;){
 if ((token = scan()) == EOF){symbol_table_dump();return(0);}; 


};
}


int token_dump(token)int token;{
int i,k;

/* 
if (token < 43) printf(" %s ",token_map[token]);
*/
if ((token < 0) || (token > 44)) {printf("<bad token>: %3d ",token); return 0;};
/* if ((token != 28) & (token != 29) & (token != 30) & (token < 43)) printf(" %s ",token_map[token]); */

if (token == 28) printf(" %d ",scanned_constant_value);
if (token == 29) for(i=0; scanned_string[i] !=0;i++)printf("%c",scanned_string[i]);
if (token == 30) {       k = symbol_string_list_index[scanned_identifier_index];
	for(i=k; symbol_string_list[i] !=0;i++)printf("%c",symbol_string_list[i]);
	};
printf(" %s ",token_map[token]);
}

void token_print(token)int token;{

if ((token < 0) || (token > 44)) 
 printf("<bad token>: %3d ",token);
else
 printf(" %s ",token_map[token]);

}


int symbol_table_dump(){
	int i,k,m;
	for(m=0;m<next_symbol_index;m++){       k = symbol_string_list_index[symbol_sorted_order[m]];
	      printf("symbol table at entry %2d,",m);
	      for(i=k; symbol_string_list[i] !=0;i++)printf("%c",symbol_string_list[i]);
	      printf("\n");
	};
	for(m=0;m<next_symbol_index;m++){       k = symbol_string_list_index[m];
		printf("symbol table at entry %2d,",m);
		for(i=k; symbol_string_list[i] !=0;i++)printf("%c",symbol_string_list[i]);
		printf("\n");
	};
}


int scan(){
int state;

state = 0;
scanned_identifier_length = 0;
scanned_string_length = 0;
scanned_constant_value = 0;

for(;;){
if (ch_look_ahead == 0){if (scanf("%c",&ch) == EOF) { return(EOF);};/*printf("%c",ch);*/};	
if (ch_look_ahead != 0){ch = ch_look_ahead; ch_look_ahead = 0;};
ch = ch & 0x7f;

switch(state){
	case 0:
		if ((character_type_map[ch] == 4))break;
	        if ((character_type_map[ch] & 0x01) == 1) {ch_look_ahead = ch; state = 1;break;};
		if((character_type_map[ch] == 8)){
			switch(ch){
				case '/':
					state = 2;
					break;
				case '<':
					state = 3;
					break;
				case '>':
					state = 4;
					break;
				case '!':
					state = 5;
					break;
				case '=':
					state = 6;
					break;
				case '"':
					state = 13;
					break;
				case '\'':
					state = 14;
					break;
				default:
					return(character_operator_map[ch]);

			};
			break;


		};
		if ((character_type_map[ch] & 16) == 16) {state = 7; scanned_constant_value = ch - '0'; break;};
		if (character_type_map[ch] == 64) {state = 8; break;};

		break;

	case 1:
		if ((character_type_map[ch] & 0x02) == 2) {
			if (scanned_identifier_length <identifier_length_limit)
		           {scanned_identifier[scanned_identifier_length] = ch;
			    scanned_identifier_length = scanned_identifier_length + 1;
			    scanned_identifier[scanned_identifier_length] = 0;
			    };
			break;};
		ch_look_ahead = ch;
		scanned_identifier_index = symbol_table_lookup();
                return(symbol_value_1[scanned_identifier_index]);
	case 2:
		if (ch == '*')
			state = 9;
		else
		{ch_look_ahead = ch; return(character_operator_map['/']);};
		break;
	case 3:
		if (ch == '<')
			return(23/*left shift op*/);
		else
		{
			if (ch == '=')
				return(25/*less than or equal op*/);
			else
		{ch_look_ahead = ch; return(character_operator_map['<']);};
		};
		break;
	case 4:
		if (ch == '>')
			return(22/*right shift op*/);
		else
		{
			if (ch == '=')
				return(24/*greater than or equal op*/);
			else
		{ch_look_ahead = ch; return(character_operator_map['>']);};
		};
		break;
	case 5:
		if (ch == '=')
			return(26/*inequality op*/);
		else
		{ch_look_ahead = ch; return(character_operator_map['!']);};
		break;
	case 6:
		if (ch == '=')
			return(27/*equality op*/);
		else
		{ch_look_ahead = ch; return(character_operator_map['=']);};

		break;
	case 7:
		if (((ch == 'x') | (ch == 'X')) & (scanned_constant_value == 0))
			state = 11;
		else
		{
			if ((character_type_map[ch] & 16) == 16) 
			{scanned_constant_value = (scanned_constant_value * 10) + ch - '0'; state = 12;}
			else
			{ch_look_ahead = ch; return(28/*constant*/);};

		};
		break;
	case 8:
		switch(ch){
			case 'n':
				scanned_constant_value = '\n';
				break;
			case 't':
				scanned_constant_value = '\n';
				break;
			case 'b':
				scanned_constant_value = '\b';
				break;
			case 'r':
				scanned_constant_value = '\r';
				break;
			case 'f':
				scanned_constant_value = '\f';
				break;
			case '\\':
				scanned_constant_value = '\\';
				break;
			case '\'':
				scanned_constant_value = '\'';
				break;
			case '0':
				scanned_constant_value = 0;
				break;
			case 1: case 2: case 3: case 4: case 5: case 6: case 7: /* should these have single quotes? */
				scanned_constant_value = ch - '0';
				state = 21;
				break;
			default:
				state = 0;
				break;




		};
		if ((state != 0) & (state != 21))return(28/*constant*/);
		break;
	case 9:
		if (ch == '*') state = 10;
		break;
	case 10:
		if (ch == '/')
			state = 0;
		else
			state = 9;
		break;
	case 11:
		if ((character_type_map[ch] & 32) == 32)
		{
			scanned_constant_value = (scanned_constant_value * 16) + ch;
			if (ch >= 'A')
			{
				if (ch >= 'a')
				scanned_constant_value = scanned_constant_value - 'a' + 10;
			else
				scanned_constant_value = scanned_constant_value - 'A' + 10;
			}
			else
				scanned_constant_value = scanned_constant_value - '0';

		}
		else
		{ch_look_ahead = ch; return(28/*constant*/);};

		break;
	case 12:
		if ((character_type_map[ch] & 16) == 16)
		scanned_constant_value = (scanned_constant_value * 10) + ch - '0'; 
		else
		{ch_look_ahead = ch; return(28/*constant*/);};

		break;
	case 13:
		if (ch != '"') {
			if (scanned_string_length < scanned_string_limit)
			{
			 if (ch == '\\')
			 state = 15;
			 else
			 {
			        scanned_string[scanned_string_length] = ch;
				scanned_string_length = scanned_string_length + 1;
				scanned_string[scanned_string_length] = 0;
			};
			break;};
			}
			else
			return(29/*string*/);

		break;
	case 14:if (character_type_map[ch] == 64)
		state = 19;
		else
		{
			scanned_constant_value = ch;
			state = 20;
		};
		break;
	case 15:
		switch(ch){
			case 'n':
				scanned_constant_value = '\n';
				state = 16;
				break;
			case 't':
				scanned_constant_value = '\n';
				state = 16;
				break;
			case 'b':
				scanned_constant_value = '\b';
				state = 16;
				break;
			case 'r':
				scanned_constant_value = '\r';
				state = 16;
				break;
			case 'f':
				scanned_constant_value = '\f';
				state = 16;
				break;
			case '\\':
				scanned_constant_value = '\\';
				state = 16;
				break;
			case '\'':
				scanned_constant_value = '\'';
				state = 16;
				break;
			case '0':
				scanned_constant_value = 0;
				state = 16;
				break;
			case 1: case 2: case 3: case 4: case 5: case 6: case 7:
				scanned_constant_value = ch - '0';
				state = 17;
				break;
			default:
				ch_look_ahead = ch;
				state = 13;
				break;

		};
		break;
	case 16:
		ch_look_ahead = ch;
		scanned_string[scanned_string_length] = scanned_constant_value;
		scanned_string_length = scanned_string_length + 1;
		scanned_string[scanned_string_length] = 0;
		state = 13;
		break;
	case 17:
		if ( (ch >= '0') & (ch <= '7')) {
		scanned_constant_value = (scanned_constant_value * 8) + ch - '0';
		state = 18;
		}
		else
		{
			ch_look_ahead = ch;
			state = 16;
		};
		break;
	case 18:
		if ( (ch >= '0') & (ch <= '7'))
			scanned_constant_value = (scanned_constant_value * 8) + ch - '0';
		else
			ch_look_ahead = ch;
		state = 16;
		break;
	case 19:
		switch(ch){
			case 'n':
				scanned_constant_value = '\n';
				state = 20;
				break;
			case 't':
				scanned_constant_value = '\n';
				state = 20;
				break;
			case 'b':
				scanned_constant_value = '\b';
				state = 20;
				 break;
			case 'r':
				 scanned_constant_value = '\r';
				 state = 20;
				 break;
			case 'f':
				 scanned_constant_value = '\f';
				 state = 20;
				 break;
			case '\\':
				 scanned_constant_value = '\\';
				 state = 20;
				 break;
			case '\'':
				 scanned_constant_value = '\'';
				 state = 20;
				 break;
			case '0':
				 scanned_constant_value = 0;
				 state = 20;
				 break;
			case 1: case 2: case 3: case 4: case 5: case 6: case 7:
				 scanned_constant_value = ch - '0';
				 state = 21;
				 break;
			default:
				 scanned_constant_value = ch;
				 state = 20;
				 break;

		};

		break;
	case 20:
		if (ch != '\'')
			ch_look_ahead = ch;

		return(28 /*constant*/);
		break;
	case 21:
		if ( (ch >= '0') & (ch <= '7')) {
			scanned_constant_value = (scanned_constant_value * 8) + ch - '0';
			state = 22;
		}
		else
		{
			ch_look_ahead = ch;
			state = 20;
		};

		break;
	case 22:
		if ( (ch >= '0') & (ch <= '7'))
			scanned_constant_value = (scanned_constant_value * 8) + ch - '0';
		else
			ch_look_ahead = ch;
		state = 20;

		break;
};

}

}

 symbol_table_lookup(){
	 int i,j,k,m,n,u,v;
for (m = (next_symbol_index-1)/2, u = 0, v = (next_symbol_index-1),n = 0; (u <= v) && (n >= 0); m = (u+v)/2)
{
	k = symbol_string_list_index[symbol_sorted_order[m]];
	for (i = k,j = 0; (symbol_string_list[i] != 0) | (scanned_identifier[j] != 0); i++,j++)
	{
		if (symbol_string_list[i] > scanned_identifier[j])
		{
			 v = m-1;
			 n = m;
			 break;
		}
		else
			if (symbol_string_list[i] < scanned_identifier[j])
			{
				u = m+1;
				n = m+1;
				break;
			}
			else
				n = -1;
	}
	;
	if (n < 0)
	{
	/*	printf("n<0; m= %3d\n",m); */
		/* found matching symbol */
		return(symbol_sorted_order[m]);
	}
	;
}
/* since no existing symbol matches, then insert the new symbol in the symbol table. */
if ( (n >= 0) & (next_symbol_index < symbol_index_limit))
{
	/*printf("n>=0, n= %3d\n",n);*/
	 if(n < next_symbol_index)
		 for(i=next_symbol_index; i>n; i--)
			 symbol_sorted_order[i] = symbol_sorted_order[i-1];
	 symbol_sorted_order[n] = next_symbol_index;
	 for (i = 0,j = next_string_list; (scanned_identifier_length >= i) & (j < string_list_limit); i++,j++)
		 symbol_string_list[j] = scanned_identifier[i];


	 symbol_string_list_index[next_symbol_index] = next_string_list;

	 next_string_list = j + 1;

	 symbol_value_1[next_symbol_index] = 30;

	 next_symbol_index = next_symbol_index + 1;


	 return(symbol_sorted_order[n]);


}
else
	return (0);
	}
/**************************************************************************************/
/* code generation and parsing follows */
int testprint=0;
int j, scan_index, current_token, current_token_value;

/**************************************************************************************/
/* code generation first */


#define AC 1
#define TMP 2
#define VAR 3
#define CODE 4

#define NE 0
#define GE 1
#define LE 2
#define GT 3
#define LT 4

char* condition_code[] = {"BC NE ","BC GE ","BC LE ","BC GT ","BC LT ",};

int opnd_type_stk[100],opnd_value_stk[100];
int opnd_index, opnd_stack_index, codegen_index;
int loccntr;
int mem[1000];
int acflg, save_dest_type,save_dest_value;
int cond, btrue, bfalse;

int tmpstk[3];
int tmpstk_index;

void temp_init()
{
int i,j;
for(i = 0, j = sizeof(tmpstk)/sizeof(int)-1; j >= 0; i++, j--) tmpstk[j] = i;
tmpstk_index = i - 1;
for(i = 0; i < sizeof(tmpstk)/sizeof(int); i++) printf("tmpstk[%d]:%d\n",i, tmpstk[i]);
}

int temp_gen()
{
int tmp;
if (tmpstk_index >= 0)
 {
 printf("gen: tmpstk_index: %3d\n",tmpstk_index);
 tmp = tmpstk[tmpstk_index];
 tmpstk_index--;
 printf("supplying __tmp%03d\n",tmp);
 return tmp;
 }
 else
 printf("no more temps are available to allocate; default is used\n");
 return 0;
}

void temp_free(int tmp)
{
 printf("free: tmpstk_index: %3d\n",tmpstk_index);
if ((tmpstk_index + 1) >= sizeof(tmpstk)/sizeof(int) )
 printf("too many temps freed\n");
 else
 {
  tmpstk_index++;
  tmpstk[tmpstk_index] = tmp;
 }
return; 
}

void codegen_init()
{
 temp_init();
 opnd_index = 0;
 loccntr = 0;
 acflg = 0;
}

void emit(char* opcode, int type, int value, int* len)
{
 int i;

 if (type == -1) {printf("%s\n",opcode);return;};

 printf("%06x %s",loccntr, opcode);

 switch (type)
  {
   case AC:
          printf("AC is improper operand here\n");
	  *len = 0;
	  break;
   case TMP:
          printf("__tmp%03d\n",value);
	  printf("value: %d\n",value);
	  *len = 4;
	  break;
   case VAR:
		 for(i=symbol_string_list_index[value]; symbol_string_list[i] !=0;i++)printf("%c",symbol_string_list[i]);
		 printf("\n");
		 *len = 4;
		 break;

   case CODE:
          printf("0x%08x\n",value);
	  *len = 4;
	  break;
   case 0:
   default:
          printf("\n");
	  *len = value;
	  break;
  };
}

void forceacc(int order)
{
 int temp, len;
 if( (acflg < (opnd_index - 1)) && (acflg != 0))
 {
  temp = temp_gen();
  emit("ST 3,", TMP, temp, &len);
  opnd_type_stk[acflg] = TMP;
  opnd_value_stk[acflg] = temp;
  loccntr = loccntr + len;
  acflg = 0;
 };

 if ((acflg == 0) && (order == 0))
 {
  emit("L 3,",opnd_type_stk[opnd_index - 1], opnd_value_stk[opnd_index - 1], &len);
  loccntr = loccntr + len;
  if (opnd_type_stk[opnd_index - 1] == TMP) temp_free(opnd_value_stk[opnd_index - 1]);
  opnd_type_stk[opnd_index - 1] = AC;
  opnd_value_stk[opnd_index - 1] = 3;
  acflg = opnd_index - 1;
 };
 if ((acflg == 0) && (order == 1))
  {
    emit("L 3,",opnd_type_stk[opnd_index], opnd_value_stk[opnd_index], &len);
      loccntr = loccntr + len;
        if (opnd_type_stk[opnd_index] == TMP) temp_free(opnd_value_stk[opnd_index]);
	  opnd_type_stk[opnd_index] = AC;
	    opnd_value_stk[opnd_index] = 3;
	      acflg = opnd_index;
	       };
 codegen_index = (acflg == opnd_index)? (opnd_index - 1):opnd_index;

}


void semantic_action(int action)
{
 int len;
 char string[40];
 if (action <= 0) return;
 printf("******** semantic action %3d\n",action);
 printf("acflg: %3d, opnd_index: %3d\n",acflg,opnd_index);
  
 switch (action)
 {
  case 1:
/*      save_dest_type = (current_token == 30)?VAR:0;
      save_dest_value = current_token_value;
*/
         opnd_index = opnd_index + 1;
	       opnd_type_stk[opnd_index] = (current_token == 30)?VAR:0;
	             opnd_value_stk[opnd_index] = current_token_value;

  break;
  case 2:
    forceacc(1);
/*      emit("ST 3,", save_dest_type, save_dest_value, &len);*/
emit("ST 3,", opnd_type_stk[codegen_index],opnd_value_stk[codegen_index], &len);
      loccntr = loccntr + len;
      break;
  case 3:
      forceacc(0);
      emit("A 3,", opnd_type_stk[codegen_index],opnd_value_stk[codegen_index], &len);
      loccntr = loccntr + len;
      if (opnd_type_stk[codegen_index] == TMP) temp_free(opnd_value_stk[codegen_index]);
      acflg = opnd_index - 1;
      opnd_index = acflg;
      opnd_type_stk[opnd_index] = AC;
      opnd_value_stk[opnd_index] = 3;
      break;
  case 4:
      forceacc(0);
      emit("XR 2,2", 0, 2, &len);
      loccntr = loccntr + len;
      emit("M 2,", opnd_type_stk[codegen_index],opnd_value_stk[codegen_index], &len);
      loccntr = loccntr + len;
      if (opnd_type_stk[codegen_index] == TMP) temp_free(opnd_value_stk[codegen_index]);
      acflg = opnd_index - 1;
      opnd_index = acflg;
      opnd_type_stk[opnd_index] = AC;
      opnd_value_stk[opnd_index] = 3;
      break;
  case 5:
      opnd_index = opnd_index + 1;
      opnd_type_stk[opnd_index] = (current_token == 30)?VAR:0;
      opnd_value_stk[opnd_index] = current_token_value;
      break;
  case 6:
      break;
  case 7:
      btrue = loccntr;
      loccntr = loccntr + 4;
/*      emit(condition_code[cond], CODE, loccntr, &len);
      sprintf(string,"FIXUP 0x%08x,",bfalse);
      emit(string,CODE,loccntr,&len);
*/
  sprintf(string,"%06x %s 0x%08x",bfalse,condition_code[cond], loccntr);
  emit(string, -1,0,&len);
/*no loccntr change*/
      break;
  case 8:/* this may need fixing*/
/*      emit("B ", CODE, loccntr, &len);
      loccntr = loccntr + len;
      sprintf(string,"FIXUP 0x%08x,",btrue);
      emit(string,CODE,loccntr,&len);
*/
  sprintf(string,"%06x B 0x%08x",btrue, loccntr);
    emit(string, -1,0,&len);


break;
  case 9:
  case 10:
  case 11:
      forceacc(0);
      if (action == 9) cond = NE;
      if (action == 10) cond = (opnd_index == codegen_index)?LE:GE;
      if (action == 11) cond = (opnd_index == codegen_index)?LT:GT;
      emit("C 3,", opnd_type_stk[codegen_index],opnd_value_stk[codegen_index], &len);
      opnd_index = opnd_index - 2;
      acflg = 0;
      loccntr = loccntr + len;
      bfalse = loccntr;
      loccntr = loccntr + 4;
      break;
  default:
      return;
 };
}


/**************************************************************************************/

/* parser */
/* Slimmick's version of Conway's parser: */




int conway_parser()
{
codegen_init();
j = 1;
scan_index = j;
current_token = scan();
if(current_token == -1) return 1;
if(takepath(1) == TRUE)
 printf("legal\n\n");
 else
 printf("illegal\n\n");
return (0);
}

void semantic_action_orig(int i)
{
printf("******** semantic action %3d\n",i);
}


int sym(int i)
{
if(i == scan_index) 
  {  if(testprint != 0) printf("index:%3d, scan_index:%3d, current_token:%3d is: ",i, scan_index, current_token);
  if(testprint != 0) token_dump(current_token);
  if(testprint != 0) printf("\n");
  return current_token;}
 else
  if (i > scan_index)
  {
  current_token = scan();
  current_token_value = 0;
  if (current_token == 28) current_token_value = scanned_constant_value;
  if (current_token == 30) current_token_value = scanned_identifier_index;
  if(testprint != 0) printf("index:%3d, scan_index:%3d, current_token:%3d is: ",i, scan_index, current_token);
  /*if(testprint != 0)*/  token_dump(current_token);
  /*if(testprint != 0)*/ printf("\n");
  scan_index = i;
  return current_token;};

 printf("can't backup scanner\n");
 if(testprint != 0) printf("index:%3d, scan_index:%3d, current_token:%3d\n",i, scan_index, current_token);
 return current_token;
}

int terminal(int i){return ( (i < NONTERMINAL) && (i > 0) );}
int nonterminal(int i){return (i >= NONTERMINAL);}

int takepath_orig(int k)
{
/*recursive original version*/
int jsave, i;
printf("parsing diagram rooted at node %3d\n",k);
 i = k;

 for(;(i != EMPTY) && (parse_table_token[i] != EXHAUSTED);)
   {
   printf("checking token %3d at node %3d\n",parse_table_token[i], i);
    if(terminal(parse_table_token[i]))
     {
     printf("looking for "); token_print(parse_table_token[i]); printf("\n");
       if(parse_table_token[i] == sym(j))
        {
	printf("terminal token matched at node %3d\n",i);
	semantic_action(parse_table_action[i]);
         j = j+1;
	 i = parse_table_control[i];
	}
	else
	{printf("terminal token mismatched at node %2d\n",i);
	i = i+1;};

     } 
     else
     {
       if(nonterminal(parse_table_token[i]))
       {printf("checking nonterminal token %3d (node %3d) from node %3d\n",parse_table_token[i], parse_table_token[i] - NONTERMINAL, i);
         jsave = j;
	 if(takepath(parse_table_token[i] - NONTERMINAL))
	   {printf("accepted nonterminal token %3d (node %3d) from node %3d\n",parse_table_token[i], parse_table_token[i] - NONTERMINAL,i);
	   semantic_action(parse_table_action[i]);
	   i = parse_table_control[i];}
	   else
	   {printf("rejected nonterminal token %3d (node %3d) from node %3d\n",parse_table_token[i], parse_table_token[i] - NONTERMINAL,i);
            j = jsave;
	    i = i+1;
	   }
       }
       else
       {
        if(parse_table_token[i] == EMPTY)
	  {printf("empty token accepted at node %3d\n",i);semantic_action(parse_table_action[i]);i = parse_table_control[i];}
	 else
	  {printf("error1 at node %3d\n", i);
	  return(FALSE);};
       };
     }
   };

   if(i == EMPTY)
    return(TRUE);
    else
     {
      if(parse_table_control[i] == EMPTY /*EXHAUSTED*/)
       {printf("error2a at node %3d\n", i);
       return(FALSE);}
       else
        {/* printf("error2b at node %3d\n", i); */
	 return (FALSE);};
     }
}



int takepath(int k)
{
/*version using explicit stack instead of recursion*/
int parse_table_stack[100], token_stack[100];
int stack_index, recurse, return_value;
int i;

stack_index = 0;
recurse = 0;

parse_table_stack[0] = 0;
token_stack[0] = -1;

i = k;

for (;;)
{
  if(testprint != 0)printf("parsing diagram rooted at node %3d\n",i);


 for(;(i != EMPTY) && (parse_table_token[i] != EXHAUSTED) && (recurse == 0);)
   {
   if(testprint != 0)printf("checking token %3d at node %3d\n",parse_table_token[i], i);
    if(terminal(parse_table_token[i]))
     {
     if(testprint != 0) printf("looking for "); if(testprint != 0) token_print(parse_table_token[i]); if(testprint != 0) printf("\n");
       if(parse_table_token[i] == sym(j))
        {
        if(testprint != 0) printf("terminal token matched at node %3d\n",i);
        semantic_action(parse_table_action[i]);
         j = j+1;
         i = parse_table_control[i];
        }
        else
        {
	if(testprint != 0) printf("terminal token mismatched at node %3d\n",i);
        i = i+1;};

     }
     else
     {
       if(nonterminal(parse_table_token[i]))
       {
	 recurse = 1;
       }
       else
       {
        if(parse_table_token[i] == EMPTY)
          {
	  if(testprint != 0) printf("empty token accepted at node %3d\n",i);
	  semantic_action(parse_table_action[i]);
	  i = parse_table_control[i];
	  }
         else
          {
	  printf("error1 at node %3d\n", i);
          return(FALSE);
	  };
       };
     };
   };
  if(recurse == 0)
  {
   if(i == EMPTY)
    return_value = TRUE;
    else
     {
      if(parse_table_control[i] == EMPTY /*EXHAUSTED*/)
       {printf("error2 at node %3d\n", i);
       return(FALSE);}
       else
        {
         return_value = FALSE;
	 };
     };
     if (stack_index > 0)
      {
      stack_index--;
       if (return_value == TRUE)
        {
	if(testprint != 0) printf("accepted nonterminal token %3d (node %3d) from node %3d\n",parse_table_token[parse_table_stack[stack_index]],
	                parse_table_token[parse_table_stack[stack_index]] - NONTERMINAL,parse_table_stack[stack_index]);
	semantic_action(parse_table_action[parse_table_stack[stack_index] ]);
	i = parse_table_control[parse_table_stack[stack_index] ];
	}
	else
	{
	if(testprint != 0) printf("rejected nonterminal token %3d (node %3d) from node %3d\n",parse_table_token[parse_table_stack[stack_index]], parse_table_token[parse_table_stack[stack_index]] - NONTERMINAL,parse_table_stack[stack_index]);
	j = token_stack[stack_index];
	i = parse_table_stack[stack_index] + 1;
	};

     }
     else
     return(return_value);
   }
   else
   {
          if(testprint != 0) printf("checking nonterminal token %3d (node %3d) from node %3d\n",parse_table_token[i],
          parse_table_token[i] - NONTERMINAL, i);
          token_stack[stack_index] = j;
          parse_table_stack[stack_index] = i;
          i = parse_table_token[i] - NONTERMINAL;
          stack_index++;

   recurse = 0;
   };

  };

}

