/* c-.c adapted to generate its parser tables*/
#define gcc 1
#if gcc
#include <stdio.h>
#include <time.h>
#else
#include "..\include\time.h"
#include "..\include\stdio.h"
#endif


int testprint=3;

int ch = 0;
int ch_look_ahead = 0;

int identifier_length_limit = 128;
int scanned_identifier_length;
int scanned_identifier[129];
int scanned_identifier_index;

int scanned_string_limit = 1000;
int scanned_string_length;
int scanned_string[1001];
int scanned_string_index;
int scanned_constant_value;


int line_no;

/*
1 initial identifier A-Z a-z _ $
2 internal indentifier A-Z a-z _ $ 0-9
4 whitespace space tab cr lf vt ff
8 operator ! " % ' ( ) * + , - / ;  : < = > [ ] { | } # $
16 number 0-9
32 hex number A-F a-f 0-9
64 escape
*/
int character_type_map[128]  = {
			       0,0,0,0,0,0,0,0,0,4,4,4,4,4,0,0,
			       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
			       4,8,8,8,3,8,8,8,8,8,8,8,8,8,0,8,
			       50,50,50,50,50,50,50,50,50,50,8,8,8,8,8,8,
			       0,35,35,35,35,35,35,3,3,3,3,3,3,3,3,3,
			       3,3,3,3,3,3,3,3,3,3,3,8,64,8,0,3,
			       0,35,35,35,35,35,35,3,3,3,3,3,3,3,3,3,
			       3,3,3,3,3,3,3,3,3,3,3,8,8,8,0,0,
                               };

int character_operator_map[128]  = {
	                           0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
				   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
				   0,1,0,45,0,21,3,0,5,6,7,8,9,10,0,11,
				   0,0,0,0,0,0,0,0,0,0,4,12,13,14,15,2,
				   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
				   0,0,0,0,0,0,0,0,0,0,0,16,0,17,0,0,
				   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
				   0,0,0,0,0,0,0,0,0,0,0,18,19,20,0,0,
                                 };


					    


int next_symbol_string_list = 78;
int symbol_string_list_limit = 10000;
int symbol_string_list[10000] =
                    {'0',
                     /* 1 */
	             'b','r','e','a','k',0,
		     /* 7 */
	             'c','a','s','e',0,
		     /* 12 */
		     'c','o','n','t','i','n','u','e',0,
		     /* 21 */
		     'd','e','f','a','u','l','t',0,
		     /* 29 */
		     'd','o',0,
		     /* 32 */
		     'e','l','s','e',0,
		     /* 37 */
		     'f','o','r',0,
		     /* 41 */
		     'g','o','t','o',0,
		     /* 46 */
		     'i','f',0,
		     /* 49 */
		     'i','n','t',0,
		     /* 53 */
		     'r','e','t','u','r','n',0,
		     /* 60 */
		     's','w','i','t','c','h',0,
		     /* 67 */
		     'v','o','i','d',0,
		     /* 72 */
		     'w','h','i','l','e',0,
		     /* 78 */
		    };

char * token_map[] ={"null", "!", "?", "&", ":", "(", ")", "*", "+", ",",
                    "-", "/", ";", "<", "=", ">", "[", "]", "{", "|",
		    "}", "%", ">>", "<<", ">=", "<=", "!=", "==", "<constant>", "<string>",
		    "<identifier>", "break", "case", "continue", "default", "do", "else", "for", "goto", "if",
		    "int", "return", "switch", "void", "while", "#",};

int token_types = sizeof(token_map)/sizeof(char*);

#define CONST  28
#define STRING  29
#define IDENT  30
#define LINK  (sizeof(token_map)/sizeof(char*) + 2)


int symbol_index_limit = 256;
int next_symbol_index = 14;
int first_identifier_index = 14;
int symbol_string_list_index[256]=  {  1,  7, 12, 21, 29, 32, 37, 41, 46, 49, 53, 60, 67, 72, };
int symbol_sorted_order[256] =      {  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, };
int symbol_value_1[256] =           { 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, };
int symbol_value_2[256] =           {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, };
int symbol_value_3[256] =           {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, };
int symbol_value_4[256] =           {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, };


#define EMPTY (-1)
#define EXHAUSTED (-2)
#define NONTERMINAL (1024)

#define TRUE (1==1)
#define FALSE (1==0)

#undef PRODLABELS

#if 0

/* orig hand coded tables used to bootstrap generated tables for bnf parser/table generator */
int parse_table_token[] = {
	                    /* 0 */
                           EMPTY,
			   3+NONTERMINAL,
			   EMPTY,
			   45,
			   5+NONTERMINAL,
			   30,
			   EMPTY,
			   45,
			   EXHAUSTED,
			   45,
			    /* 10 */
			    12+NONTERMINAL,
			    EXHAUSTED,
			    1,
			    2,
			    3,
			    4,
			    5,
			    6,
			    7,
			    8,
			    /* 20 */
			    9,
			    10,
			    11,
			    12,
			    13,
			    14,
			    15,
			    16,
			    17,
			    18,
			    /* 30 */
			    19,
			    20,
			    21,
			    22,
			    23,
			    24,
			    25,
			    26,
			    27,
			    28,
			    /* 40 */
			    29,
			    30,
			    31,
			    32,
			    33,
			    34,
			    35,
			    36,
			    37,
			    38,
			    /* 50 */
			    39,
			    40,
			    41,
			    42,
			    43,
			    EXHAUSTED,
			    28,
			    29,
			    30,
			    EXHAUSTED,
			    /* 60 */
			    45,
			    EXHAUSTED,
			    29,
			    30,
			    EXHAUSTED,

                          };

int parse_table_action[] = {
                            /* 0 */
			    EMPTY,
			    1,
			    EMPTY,
			    EMPTY,
			    2,
			    3,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
                            /* 10 */
			    4,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
                            /* 20 */
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
                            /* 30 */
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
                            /* 40 */
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
                            /* 50 */
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    5,
			    5,
			    5,
			    EMPTY,
			    /* 60 */
			    EMPTY,
			    EMPTY,
			    6,
			    6,
			    EMPTY,
                            };
int parse_table_control[] = {
                            /* 0 */
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    3,
			    7,
			    EMPTY,
			    9,
			    EMPTY,
			    56,
                            /* 10 */
			    9,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
                            /* 20 */
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
                            /* 30 */
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
                            /* 40 */
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
                            /* 50 */
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    60,
			    60,
			    60,
			    EMPTY,
			    /* 60 */
			    62,
			    EMPTY,
			    EMPTY,
			    EMPTY,
			    EMPTY,
		           };


#else

#include "cxparsetab.h"

#if 0
/* trial table*/
/* generated tables */


int parse_table_token[] = {
      0,
      4+NONTERMINAL,
    EMPTY,
      EXHAUSTED,
      45,
     17+NONTERMINAL,
      EXHAUSTED,
      45,
      EXHAUSTED,
     19+NONTERMINAL,
      EXHAUSTED,
     66+NONTERMINAL,
      EXHAUSTED,
      45,
      EXHAUSTED,
     70+NONTERMINAL,
      EXHAUSTED,
      30,
      EXHAUSTED,
      45,
     22+NONTERMINAL,
      EXHAUSTED,
       1,
       2,
       3,
       4,
       5,
       6,
       7,
       8,
       9,
      10,
      11,
      12,
      13,
      14,
      15,
      16,
      17,
      18,
      19,
      20,
      21,
      22,
      23,
      24,
      25,
      26,
      27,
      28,
      29,
      30,
      31,
      32,
      33,
      34,
      35,
      36,
      37,
      38,
      39,
      40,
      41,
      42,
      43,
      EXHAUSTED,
      28,
      29,
    EMPTY,
      EXHAUSTED,
      29,
      30,
      EXHAUSTED,
     };


int parse_table_action[] = {
        0,
        1,
    EMPTY,
      EMPTY,
    EMPTY,
      EMPTY,
      EMPTY,
      EMPTY,
      EMPTY,
      EMPTY,
      EMPTY,
      EMPTY,
      EMPTY,
      EMPTY,
      EMPTY,
        2,
      EMPTY,
        3,
      EMPTY,
    EMPTY,
        4,
      EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
    EMPTY,
      EMPTY,
        5,
        5,
    EMPTY,
      EMPTY,
        6,
        6,
      EMPTY,
     };


int parse_table_control[] = {
      0,
EMPTY,
EMPTY,
    EMPTY,
EMPTY,
      7,
    EMPTY,
      9,
    EMPTY,
     11,
    EMPTY,
     13,
    EMPTY,
     15,
    EMPTY,
      4,
    EMPTY,
EMPTY,
    EMPTY,
EMPTY,
     19,
    EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
EMPTY,
    EMPTY,
EMPTY,
EMPTY,
EMPTY,
    EMPTY,
EMPTY,
EMPTY,
    EMPTY,
     };
/* bnf type input to generate these tables*/

#if 0

top # prodlist # 1 # "EMPTY"
top # "EMPTY" # "EMPTY" # "EMPTY"
prodlist # 45 # "EMPTY" # "EMPTY"
prodlist # label 45 tokenlist action 45 sequence # 2 # prodlist
label # 30 # 3 # "EMPTY"
tokenlist # 45 # "EMPTY" # "EMPTY"
tokenlist # tokens # 4 # tokenlist
tokens # 1 # "EMPTY" # "EMPTY"
tokens # 2 # "EMPTY" # "EMPTY"
tokens # 3 # "EMPTY" # "EMPTY"
tokens # 4 # "EMPTY" # "EMPTY"
tokens # 5 # "EMPTY" # "EMPTY"
tokens # 6 # "EMPTY" # "EMPTY"
tokens # 7 # "EMPTY" # "EMPTY"
tokens # 8 # "EMPTY" # "EMPTY"
tokens # 9 # "EMPTY" # "EMPTY"
tokens # 10 # "EMPTY" # "EMPTY"
tokens # 11 # "EMPTY" # "EMPTY"
tokens # 12 # "EMPTY" # "EMPTY"
tokens # 13 # "EMPTY" # "EMPTY"
tokens # 14 # "EMPTY" # "EMPTY"
tokens # 15 # "EMPTY" # "EMPTY"
tokens # 16 # "EMPTY" # "EMPTY"
tokens # 17 # "EMPTY" # "EMPTY"
tokens # 18 # "EMPTY" # "EMPTY"
tokens # 19 # "EMPTY" # "EMPTY"
tokens # 20 # "EMPTY" # "EMPTY"
tokens # 21 # "EMPTY" # "EMPTY"
tokens # 22 # "EMPTY" # "EMPTY"
tokens # 23 # "EMPTY" # "EMPTY"
tokens # 24 # "EMPTY" # "EMPTY"
tokens # 25 # "EMPTY" # "EMPTY"
tokens # 26 # "EMPTY" # "EMPTY"
tokens # 27 # "EMPTY" # "EMPTY"
tokens # 28 # "EMPTY" # "EMPTY"
tokens # 29 # "EMPTY" # "EMPTY"
tokens # 30 # "EMPTY" # "EMPTY"
tokens # 31 # "EMPTY" # "EMPTY"
tokens # 32 # "EMPTY" # "EMPTY"
tokens # 33 # "EMPTY" # "EMPTY"
tokens # 34 # "EMPTY" # "EMPTY"
tokens # 35 # "EMPTY" # "EMPTY"
tokens # 36 # "EMPTY" # "EMPTY"
tokens # 37 # "EMPTY" # "EMPTY"
tokens # 38 # "EMPTY" # "EMPTY"
tokens # 39 # "EMPTY" # "EMPTY"
tokens # 40 # "EMPTY" # "EMPTY"
tokens # 41 # "EMPTY" # "EMPTY"
tokens # 42 # "EMPTY" # "EMPTY"
tokens # 43 # "EMPTY" # "EMPTY"
action # 28 # 5 # "EMPTY"
action # 29 # 5 # "EMPTY"
action # "EMPTY" # "EMPTY" # "EMPTY"
sequence # 29 # 6 # "EMPTY"
sequence # 30 # 6 # "EMPTY"
#


#endif

#endif

#endif

int parse_table_data[] = {
		           };
int parse_stack_limit = 100;
int parse_stack;
int parse_table;
int parse_stack_state[100],parse_stack_value1[100],parse_stack_value2[100];


void parse_table_check();
void symbol_table_init();


int next_literal_string_list = 3;
int literal_string_list_limit = 10000;
int literal_string_list[10000];
int literal_index_limit = 256;
int next_literal_index = 3;
int literal_string_list_index[256];
int literal_sorted_order[256];



int main(){
line_no = 1;
printf("#if 0\n\n");
symbol_table_init();
/*	compile(); */
if(testprint != 0) parse_table_check();
/* for (; conway_parser() == 0;); */
conway_parser();
printf("#endif\n\n");
return(0);
}

void parse_table_check()
{
int i,len;
printf("token list entries: %d\n", sizeof(parse_table_token)/sizeof(int) - 1);
printf("control list entries: %d\n", sizeof(parse_table_control)/sizeof(int) - 1);
printf("action list entries: %d\n", sizeof(parse_table_action)/sizeof(int) - 1);

len = sizeof(parse_table_token) > sizeof(parse_table_control)?sizeof(parse_table_control) : sizeof(parse_table_token);
len = len > sizeof(parse_table_action)?sizeof(parse_table_action):len;
len = len/sizeof(int);

for(i=1;i < len; i++)
 {

  printf("%3d | ", i);

  if(parse_table_token[i] == EXHAUSTED) printf(" EXHAUSTED    ");
  else
  if(parse_table_token[i] == EMPTY)     printf(" EMPTY        ");
    else
     if(parse_table_token[i] < NONTERMINAL) printf("%12s  ",token_map[parse_table_token[i]]);
  else
  printf("nonterm%3d    ",parse_table_token[i] - NONTERMINAL);

 printf("|");

 if(parse_table_action[i] == 0)     printf("            ");
 else
 if(parse_table_action[i] == EMPTY) printf(" EMPTY      ");
 else
 printf                                   (" action %3d ",parse_table_action[i]);

printf("|");

  if(parse_table_control[i] == 0)       printf("                ");
   else
    if(parse_table_control[i] == EMPTY) printf("          EMPTY ");
     else
      printf                                  (" next state %3d ",parse_table_control[i]);


 printf("|\n");

 };

}

int compile(){
	int token;
	int i,k,m;

/*	if ((token = scan()) == EOF)return(0); */

for(parse_stack = 0,parse_table = 0;;){
 if ((token = scan()) == EOF){symbol_table_dump(0);return(0);}; 


};
}


int token_dump(token)int token;{
int i,j,k;
char * cp;
j = 0;
/* 
if (token < 43) printf(" %s ",token_map[token]);
*/
if ((token < 0) || (token > token_types)) {printf("<bad token>: %3d ",token); return 0;};
/* if ((token != 28) & (token != STRING) & (token != 30) & (token < 43)) printf(" %s ",token_map[token]); */

if (token == CONST) {printf("%5d",scanned_constant_value);j = 5;};
/*if (token == 29) for(i=0; scanned_string[i] !=0;i++)printf("%c",scanned_string[i]);*/
if (token == STRING){       k = literal_string_list_index[scanned_string_index];
                  for(i=k,j=0; literal_string_list[i] !=0;i++,j++)printf("%c",literal_string_list[i]);
	        };
if (token == IDENT) {       k = symbol_string_list_index[scanned_identifier_index];
	for(i=k,j=0; symbol_string_list[i] !=0;i++,j++)printf("%c",symbol_string_list[i]);
	};
/*k = printf(" %s ",token_map[token]);*/
for(k=0,cp=token_map[token];cp[k] != 0;k++,j++) printf("%c",cp[k]);
return j;
}

void token_print(token)int token;{

if ((token < 0) || (token > token_types)) 
 printf("<bad token>: %3d ",token);
else
 printf(" %s ",token_map[token]);

}


int symbol_table_dump(int n){
	int i,k,m,p;
	for(m=n;m<next_symbol_index;m++){       k = symbol_string_list_index[symbol_sorted_order[m]];
	      printf("symbol table at entry %2d,",symbol_sorted_order[m]);
	      for(i=k,p=0; symbol_string_list[i] !=0;i++,p++)printf("%c",symbol_string_list[i]);
	      for(;p<12;p++)printf(" ");
	      printf("  %4d  %4d  %4d  %4d",symbol_value_1[symbol_sorted_order[m]],
	            symbol_value_2[symbol_sorted_order[m]],
		    symbol_value_3[symbol_sorted_order[m]],
		    symbol_value_4[symbol_sorted_order[m]] );
	      printf("\n");
	};

	printf("\n");
	for(m=n;m<next_symbol_index;m++){       k = symbol_string_list_index[m];
		printf("symbol table at entry %2d,",m);
		for(i=k,p=0; symbol_string_list[i] !=0;i++,p++)printf("%c",symbol_string_list[i]);
              for(;p<12;p++)printf(" ");
              printf("  %4d  %4d  %4d  %4d",symbol_value_1[m],
                    symbol_value_2[m],
                    symbol_value_3[m],
                    symbol_value_4[m] );

		printf("\n");
	};
}

void symbol_table_init()
{
int i;
for(i=next_symbol_index;i<symbol_index_limit;i++)
     { symbol_value_1[i] = 0; symbol_value_2[i] = 0; symbol_value_3[i] = 0; symbol_value_4[i] = 0;};
}

int scan(){
int state;
int sign;
int comment_nest;

state = 0;
sign  = 1;
comment_nest = 0;
scanned_identifier_length = 0;
scanned_string_length = 0;
scanned_string_index = 0;
scanned_constant_value = 0;

for(;;){
if (ch_look_ahead == 0)
   {
     if (scanf("%c",&ch) == EOF)
       { 
         return(EOF);
       };
     /*printf("%c",ch);*/
     if ((ch & 0x7f) == '\n')
      {
        line_no++;
	if (testprint != 0) printf("line %4d\n",line_no);
      };
   };	


if (ch_look_ahead != 0){ch = ch_look_ahead; ch_look_ahead = 0;};
ch = ch & 0x7f;

switch(state){
	case 0:
		if ((character_type_map[ch] == 4))
		  {
		      break;
		  };
	        if ((character_type_map[ch] & 0x01) == 1) {ch_look_ahead = ch; state = 1;break;};
		if((character_type_map[ch] == 8)){
			switch(ch){
				case '/':
					state = 2;
					break;
				case '<':
					state = 3;
					break;
				case '>':
					state = 4;
					break;
				case '!':
					state = 5;
					break;
				case '=':
					state = 6;
					break;
				case '"':
					state = 13;
					break;
				case '\'':
					state = 14;
					break;
                            /*    case '-':
                                        state = 23;
					sign = -1;
                                        break;
*/
				default:
					return(character_operator_map[ch]);

			};
			break;


		};
		if ((character_type_map[ch] & 16) == 16) {state = 7; scanned_constant_value = ch - '0'; break;};
		if (character_type_map[ch] == 64) {state = 8; break;};

		break;

	case 1:
		if ((character_type_map[ch] & 0x02) == 2) {
			if (scanned_identifier_length <identifier_length_limit)
		           {scanned_identifier[scanned_identifier_length] = ch;
			    scanned_identifier_length = scanned_identifier_length + 1;
			    scanned_identifier[scanned_identifier_length] = 0;
			    };
			break;};
		ch_look_ahead = ch;
		scanned_identifier_index = symbol_table_lookup();
                return(symbol_value_1[scanned_identifier_index]);
	case 2:
		if (ch == '*')
		{
		comment_nest = comment_nest + 1;
		state = 9;
		if (testprint != 0) { if(comment_nest == 1) printf("start comment\n");};
		}
		else
		if (comment_nest <= 0)
		  {ch_look_ahead = ch; return(character_operator_map['/']);}
		 else
		  state = 9;
		break;
	case 3:
		if (ch == '<')
			return(23/*left shift op*/);
		else
		{
			if (ch == '=')
				return(25/*less than or equal op*/);
			else
		{ch_look_ahead = ch; return(character_operator_map['<']);};
		};
		break;
	case 4:
		if (ch == '>')
			return(22/*right shift op*/);
		else
		{
			if (ch == '=')
				return(24/*greater than or equal op*/);
			else
		{ch_look_ahead = ch; return(character_operator_map['>']);};
		};
		break;
	case 5:
		if (ch == '=')
			return(26/*inequality op*/);
		else
		{ch_look_ahead = ch; return(character_operator_map['!']);};
		break;
	case 6:
		if (ch == '=')
			return(27/*equality op*/);
		else
		{ch_look_ahead = ch; return(character_operator_map['=']);};

		break;
	case 7:
		if (((ch == 'x') | (ch == 'X')) & (scanned_constant_value == 0))
			state = 11;
		else
		{
			if ((character_type_map[ch] & 16) == 16) 
			{scanned_constant_value = (scanned_constant_value * 10) + ( sign * (ch - '0') ); state = 12;}
			else
			{ch_look_ahead = ch;

			return(CONST/*constant*/);};

		};
		break;
	case 8:
		switch(ch){
			case 'n':
				scanned_constant_value = '\n';
				break;
			case 't':
				scanned_constant_value = '\n';
				break;
			case 'b':
				scanned_constant_value = '\b';
				break;
			case 'r':
				scanned_constant_value = '\r';
				break;
			case 'f':
				scanned_constant_value = '\f';
				break;
			case '\\':
				scanned_constant_value = '\\';
				break;
			case '\'':
				scanned_constant_value = '\'';
				break;
			case '0':
				scanned_constant_value = 0;
				break;
			case '1': case '2': case '3': case '4': case '5': case '6': case '7': /* should these have single quotes? */
				scanned_constant_value = ch - '0';
				state = 21;
				break;
			default:
				state = 0;
				break;




		};
		if ((state != 0) & (state != 21)){

		return(CONST/*constant*/);}
		break;
	case 9:
                if (ch == '/') state = 2;
		if (ch == '*') state = 10;
		break;
	case 10:

		if (ch == '/')
		{
		   comment_nest = comment_nest - 1;
		     if (comment_nest <= 0)
		       {
			state = 0;
			if (testprint != 0) printf("end comment\n");
		       }
		       else
		         state = 9;
		}
		else
		 if ( ch != '*') state = 9;
		break;
	case 11:
		if ((character_type_map[ch] & 32) == 32)
		{
			scanned_constant_value = (scanned_constant_value * 16) + ch;
			if (ch >= 'A')
			{
				if (ch >= 'a')
				scanned_constant_value = scanned_constant_value - 'a' + 10;
			else
				scanned_constant_value = scanned_constant_value - 'A' + 10;
			}
			else
				scanned_constant_value = scanned_constant_value - '0';

		}
		else
		{ch_look_ahead = ch;

		return(CONST/*constant*/);};

		break;
	case 12:
		if ((character_type_map[ch] & 16) == 16)
		scanned_constant_value = (scanned_constant_value * 10) + (sign * (ch - '0') ); 
		else
		{ch_look_ahead = ch; 

		return(CONST/*constant*/);};

		break;
	case 13:
		if (ch != '"') {
			if (scanned_string_length < scanned_string_limit)
			{
			 if (ch == '\\')
			 state = 15;
			 else
			 {
			        scanned_string[scanned_string_length] = ch;
				scanned_string_length = scanned_string_length + 1;
				scanned_string[scanned_string_length] = 0;
			};
			break;};
			}
			else
			{
       scanned_string_index = string_table_lookup(literal_index_limit, &next_literal_index, literal_string_list_limit,
                                           literal_string_list_index, literal_sorted_order, literal_string_list,
                                           &next_literal_string_list, scanned_string, scanned_string_length);
			return(STRING/*string*/);
			};

		break;
	case 14:if (character_type_map[ch] == 64)
		state = 19;
		else
		{
			scanned_constant_value = ch;
			state = 20;
		};
		break;
	case 15:
		switch(ch){
			case 'n':
				scanned_constant_value = '\n';
				state = 16;
				break;
			case 't':
				scanned_constant_value = '\n';
				state = 16;
				break;
			case 'b':
				scanned_constant_value = '\b';
				state = 16;
				break;
			case 'r':
				scanned_constant_value = '\r';
				state = 16;
				break;
			case 'f':
				scanned_constant_value = '\f';
				state = 16;
				break;
			case '\\':
				scanned_constant_value = '\\';
				state = 16;
				break;
			case '\'':
				scanned_constant_value = '\'';
				state = 16;
				break;
			case '0':
				scanned_constant_value = 0;
				state = 16;
				break;
			case '1': case '2': case '3': case '4': case '5': case '6': case '7':
				scanned_constant_value = ch - '0';
				state = 17;
				break;
			default:
				ch_look_ahead = ch;
				state = 13;
				break;

		};
		break;
	case 16:
		ch_look_ahead = ch;
		scanned_string[scanned_string_length] = scanned_constant_value;
		scanned_string_length = scanned_string_length + 1;
		scanned_string[scanned_string_length] = 0;
		state = 13;
		break;
	case 17:
		if ( (ch >= '0') & (ch <= '7')) {
		scanned_constant_value = (scanned_constant_value * 8) + ch - '0';
		state = 18;
		}
		else
		{
			ch_look_ahead = ch;
			state = 16;
		};
		break;
	case 18:
		if ( (ch >= '0') & (ch <= '7'))
			scanned_constant_value = (scanned_constant_value * 8) + ch - '0';
		else
			ch_look_ahead = ch;
		state = 16;
		break;
	case 19:
		switch(ch){
			case 'n':
				scanned_constant_value = '\n';
				state = 20;
				break;
			case 't':
				scanned_constant_value = '\n';
				state = 20;
				break;
			case 'b':
				scanned_constant_value = '\b';
				state = 20;
				 break;
			case 'r':
				 scanned_constant_value = '\r';
				 state = 20;
				 break;
			case 'f':
				 scanned_constant_value = '\f';
				 state = 20;
				 break;
			case '\\':
				 scanned_constant_value = '\\';
				 state = 20;
				 break;
			case '\'':
				 scanned_constant_value = '\'';
				 state = 20;
				 break;
			case '0':
				 scanned_constant_value = 0;
				 state = 20;
				 break;
			case '1': case '2': case '3': case '4': case '5': case '6': case '7':
				 scanned_constant_value = ch - '0';
				 state = 21;
				 break;
			default:
				 scanned_constant_value = ch;
				 state = 20;
				 break;

		};

		break;
	case 20:
		if (ch != '\'')
			ch_look_ahead = ch;

		return(CONST /*constant*/);
		break;
	case 21:
		if ( (ch >= '0') & (ch <= '7')) {
			scanned_constant_value = (scanned_constant_value * 8) + ch - '0';
			state = 22;
		}
		else
		{
			ch_look_ahead = ch;
			state = 20;
		};

		break;
	case 22:
		if ( (ch >= '0') & (ch <= '7'))
			scanned_constant_value = (scanned_constant_value * 8) + ch - '0';
		else
			ch_look_ahead = ch;
		state = 20;

		break;

        case 23:
		if ((character_type_map[ch] == 4))break;

		if (((character_type_map[ch] & 0x10) == 0x10))
		 {
		   scanned_constant_value = sign * (ch - '0');
	           state = 7;
		   break;
		 }
		else
		 {
		  ch_look_ahead = ch;
		  return(character_operator_map['-']);
		 };
                break;

};

}

}


 string_table_lookup(int  string_index_limit, int * next_string_index, int string_list_limit, int string_list_index[],
                     int string_sorted_order[], int string_list[], int * next_string_list, int string[], int string_len){
         int i,j,k,m,n,u,v;
for (m = ((*next_string_index)-1)/2, u = 0, v = ((*next_string_index)-1),n = 0; (u <= v) && (n >= 0); m = (u+v)/2)
{
        k = string_list_index[string_sorted_order[m]];
        for (i = k,j = 0; (string_list[i] != 0) || (string[j] != 0); i++,j++)
        {
                if (string_list[i] > string[j])
                {
                         v = m-1;
                         n = m;
                         break;
                }
                else
                        if (string_list[i] < string[j])
                        {
                                u = m+1;
                                n = m+1;
                                break;
                        }
                        else
                                n = -1;
        }
        ;
        if (n < 0)
        {
        /*      printf("n<0; m= %3d\n",m); */
                /* found matching string */
                return(string_sorted_order[m]);
        }
        ;
}
/* since no existing string matches, then insert the new string in the string list. */
if ( (n >= 0) & ((*next_string_index) < string_index_limit))
{
        /*printf("n>=0, n= %3d\n",n);*/
         if(n < (*next_string_index))
                 for(i=(*next_string_index); i>n; i--)
                         string_sorted_order[i] = string_sorted_order[i-1];
         string_sorted_order[n] = (*next_string_index);
         for (i = 0,j = (*next_string_list); (i < string_len) & (j < string_list_limit); i++,j++)
                 string_list[j] = string[i];


         string_list_index[(*next_string_index)] = (*next_string_list);

         *next_string_list = j + 1;

/*         symbol_value_1[next_symbol_index] = IDENT;*/

         *next_string_index = (*next_string_index) + 1;


         return(string_sorted_order[n]);


}
else
        return (0);
}


symbol_table_lookup(){
int index;
int i;
 index = 
  string_table_lookup(symbol_index_limit,&next_symbol_index, symbol_string_list_limit, symbol_string_list_index,
         symbol_sorted_order, symbol_string_list, &next_symbol_string_list, scanned_identifier, scanned_identifier_length);

if(testprint & 0x1 != 0) 
{
  printf("symbol: ");for(i=0;i<scanned_identifier_length;i++)printf("%c",scanned_identifier[i]); 	 
  printf(" index: %3d, current symbol_value_1[index]: %3d\n",index,symbol_value_1[index]);
};

if (index >= first_identifier_index) symbol_value_1[index] = IDENT;
  return (index);
}



/**************************************************************************************/
/* code generation and parsing follows */
int j, scan_index, current_token, current_token_value;

int prodlist[10000], prodtokenvalue[10000], actionlist[2048], sequencelist[2048], tokenlist[2048],tokenvaluelist[2048];
int prodlistlimit = sizeof(prodlist)/sizeof(int), actionlistlimit = sizeof(actionlist)/sizeof(int);
int sequencelistlimit = sizeof(sequencelist)/sizeof(int), tokenlistlimit = sizeof(tokenlist)/sizeof(int);
int prevprodindx, curprodindx, curprodhead, prevprodhead;
int nextavailentry;
/**************************************************************************************/
/* code generation first */
void codegen_init()
{
int i;
for(i=0;i<prodlistlimit;i++){prodlist[i] = 0;prodtokenvalue[i] = 0;};
for(i=0;i<actionlistlimit;i++)actionlist[i] = 0;
for(i=0;i<sequencelistlimit;i++)sequencelist[i] = 0;
for(i=0;i<tokenlistlimit;i++)tokenlist[i] = 0;
prevprodindx = 0;
curprodindx = 0;
curprodhead = 0;
prevprodhead = 0;
}


void semantic_action(int action)
{
 int len, i, j, k, l, prevseqfixup, altentry;

 char string[40];
 if (action <= 0) return;
 if(testprint & 0x2 != 0)
  {
   printf("******** semantic action %3d\n",action);
   printf("curprodindx: %3d,  curprodhead: %3d\n",curprodindx, curprodhead);
  };
return;

 switch (action)
 {


case 1:
  if((testprint & 0x2) != 0) printf("fixup fwd links in data table then generate three parse tables\n");
  for(i=1,l=1;i<=curprodindx;i++){
  if(l == i){if((testprint & 0x2) != 0) printf("\n");l = prodlist[i+1];};
  if((testprint & 0x2) != 0) printf("%3d: %4d   %4d ",i,prodlist[i], prodtokenvalue[i]); if (prodlist[i] == STRING)
                       {
       j = literal_string_list_index[prodtokenvalue[i]];
                  for(k=j; literal_string_list[k] !=0;k++)if((testprint & 0x2) != 0) printf("%c",literal_string_list[k]);

		       };
		       if((testprint & 0x2) != 0) printf("\n");
		    };
 /* for(i=0;i<next_literal_string_list;i++)printf("%c",(literal_string_list[i] == 0)?'\n':literal_string_list[i]);*/
  if((testprint & 0x2) != 0) printf("\n");
  {/* generate output tables from prodlist */
    /* start over */
    if((testprint & 0x2) != 0) printf("start over\n");

    curprodhead = 1;
    nextavailentry = 1;

    while(prodlist[curprodhead] > 0) /*main loop iterates over groups of alternate productions*/
      {
      if((testprint & 0x2) != 0)
       {
        printf("mainloop\n");
        printf("curprodhead: %3d, prodlist[curprodhead]: %3d\n",curprodhead,prodlist[curprodhead]);
       };


         for(i=0,j=curprodhead,k=curprodhead;prodlist[k]>0;)
	  {
	  if((testprint & 0x2) != 0) printf("j: %3d, k: %3d\n",j,k);
	    if(prodlist[j] == prodlist[k])
	      {
	       i++;/* count number of alternates for this production*/
	       prodlist[k + 5] = k + 5;
if((testprint & 0x2) != 0) printf("i: %3d, j: %3d, k: %3d\n",i, j,k);
            

	      }
	    k = prodlist[k + 1];
     
	  };


        prodlist[curprodhead + 4] = nextavailentry;
        /* reserve space for alternates */
        nextavailentry = nextavailentry + i + 1;
if((testprint & 0x2) != 0) printf("space reservation for alternates: prodlist[curprodhead + 4]:prodlist[%3d]: %3d, new nextavailentry: %3d\n",curprodhead + 4,
prodlist[curprodhead + 4], nextavailentry);



if((testprint & 0x2) != 0)   printf("alternates: %3d, for entry: %3d\n",i,curprodhead);
  for(i=1,l=1;i<=curprodindx;i++){
  if(l == i){if((testprint & 0x2) != 0) printf("\n");l = prodlist[i+1];};
  if((testprint & 0x2) != 0) printf("%3d: %4d   %4d ",i,prodlist[i], prodtokenvalue[i]); if (prodlist[i] == STRING)
                       {
       j = literal_string_list_index[prodtokenvalue[i]];
                  for(k=j; literal_string_list[k] !=0;k++)if((testprint & 0x2) != 0) printf("%c",literal_string_list[k]);

                       };
                       if((testprint & 0x2) != 0) printf("\n");
                    };


if((testprint & 0x2) != 0) printf("first definition here\n");

  if (symbol_value_3[prodlist[curprodhead]] == 0)
   {/* first definition here*/
    symbol_value_3[prodlist[curprodhead]] = prodlist[curprodhead + 4] /*nextavailentry*/;
   };
  if (symbol_value_3[prodlist[curprodhead]] < 0)
   {if((testprint & 0x2) != 0) printf("fixup3 forward references here\n");
   /*fixup forward references here*/
     for(i=symbol_value_3[prodlist[curprodhead]];i<0;)
        {
         j = tokenlist[-i];
         tokenlist[-i] = prodlist[curprodhead + 4] /*nextavailentry*/ + NONTERMINAL;
	 if((testprint & 0x2) != 0) printf("tokenlist[%3d] fixup: %3d\n",-i,prodlist[curprodhead + 4]/*nextavailentry*/);
         i = j;
        };
     symbol_value_3[prodlist[curprodhead]] = prodlist[curprodhead + 4] /*nextavailentry*/;
   };

if((testprint & 0x2) != 0) printf("finished fixup3 forward references here\n");

  if (symbol_value_4[prodlist[curprodhead]] == 0)
   {/* first definition here*/
    symbol_value_4[prodlist[curprodhead]] = prodlist[curprodhead + 4] /*nextavailentry*/;
   };
  if (symbol_value_4[prodlist[curprodhead]] < 0)
   {if((testprint & 0x2) != 0) printf("fixup forward4 references here\n");
   /*fixup forward references here*/
     for(i=symbol_value_4[prodlist[curprodhead]];i<0;)
        {
         j = sequencelist[-i];
         sequencelist[-i] = prodlist[curprodhead + 4] /*nextavailentry*/ ;
	 if((testprint & 0x2) != 0) printf("sequencelist[%3d] fixup: %3d\n",-i,prodlist[curprodhead + 4] /*nextavailentry*/);
         i = j;
        };
     symbol_value_4[prodlist[curprodhead]] = prodlist[curprodhead + 4] /*nextavailentry*/;
   };


if((testprint & 0x2) != 0) printf("finished fixup4 forward references here\n");



  if((testprint & 0x2) != 0) printf("prodlist prior to loop1 entry\n");
  for(i=1,l=1;i<=curprodindx;i++){
  if(l == i)
   {
    if((testprint & 0x2) != 0) printf("\n");
    l = prodlist[i+1];
     if(i == curprodhead)if((testprint & 0x2) != 0) printf("---------curprodhead\n");
  if((testprint & 0x2) != 0) printf("prod: ");
                       {
       k = symbol_string_list_index[prodlist[i]];
        for(j=k; symbol_string_list[j] !=0;j++)if((testprint & 0x2) != 0) printf("%c",symbol_string_list[j]);
                       };
                       if((testprint & 0x2) != 0) printf("\n");
  };
  if((testprint & 0x2) != 0) printf("%3d: %4d   %4d ",i,prodlist[i], prodtokenvalue[i]); if (prodlist[i] == STRING)
                       {
       j = literal_string_list_index[prodtokenvalue[i]];
                  for(k=j; literal_string_list[k] !=0;k++)if((testprint & 0x2) != 0) printf("%c",literal_string_list[k]);

                       };
                       if((testprint & 0x2) != 0) printf("\n");
                    };
 /* for(i=0;i<next_literal_string_list;i++)printf("%c",(literal_string_list[i] == 0)?'\n':literal_string_list[i]);*/
  if((testprint & 0x2) != 0) printf("\n");


/*
prototype loop
         for(i=0,j=curprodhead,k=curprodhead;prodlist[k]>0;)
          {
          printf("j: %3d, k: %3d\n",j,k);
            if(prodlist[j] == prodlist[k])
              {
               i++;//count number of alternates for this production
               prodlist[k + 5] = k + 5;
printf("i: %3d, j: %3d, k: %3d\n",i, j,k);


              }
            k = prodlist[k + 1];

          };

*/
        for(j=curprodhead,k=curprodhead;prodlist[k]>0;)
          {if((testprint & 0x2) != 0) printf("loop1\n");

	  if((testprint & 0x2) != 0) printf(" j: %3d  k: %3d\n",j,k);
            if(prodlist[j] == prodlist[k])
              { 
	        
		   {/* generate alternate entries first */
		  if((testprint & 0x2) != 0) printf("alternate entry at: %3d, alt production: %3d\n",prodlist[j + 4],k);
                    altentry = prodlist[j + 4];

                 if((testprint & 0x2) != 0)
		 {
		   printf("prodlist[k + 1]: %4d\n",prodlist[k + 1]);
                   printf("prodlist[k + 5]: %4d\n",prodlist[k + 5]);
		 };



                   if (prodlist[k + 5] < (prodlist[k + 1] - 1))
		     {
		     prodlist[k + 5]++;

               i = prodlist[k + 5];
               if (i == (prodlist[k + 1] - 1))
                 {/* last token in sequence*/
if((testprint & 0x2) != 0)
{
 printf("last token in sequence\n");
 printf("table entry A at %3d:\n",altentry);
 };

                 /* tokenlist*/
                 switch(prodlist[i])
                 {
                 case STRING:
                  tokenlist[altentry] = STRING;
		  tokenvaluelist[altentry] = prodtokenvalue[i];
                  break;
                 case CONST:
                  tokenlist[altentry] = CONST;
                  tokenvaluelist[altentry] = prodtokenvalue[i];
                  break;

                 case IDENT:
                  tokenlist[altentry] = symbol_value_3[prodlist[prodtokenvalue[i]]];
                  if(symbol_value_3[prodlist[prodtokenvalue[i]]] <= 0)
                    symbol_value_3[prodlist[prodtokenvalue[i]]] = -altentry; /*continue  backward fixup chain*/
                  break;
                  break;
                 case LINK:
                  tokenlist[altentry] = symbol_value_3[prodlist[prodtokenvalue[i]]];
                  if(symbol_value_3[prodlist[prodtokenvalue[i]]] <= 0)
                    symbol_value_3[prodlist[prodtokenvalue[i]]] = -altentry; /*continue  backward fixup chain*/
                   else
                    tokenlist[altentry] = tokenlist[altentry] + NONTERMINAL;
                  break;
                 default:
                  tokenlist[altentry] = prodlist[i];
                  break;
                 };
if((testprint & 0x2) != 0) printf("tokenlist[altentry:%3d]: %3d\n",altentry,tokenlist[altentry]);
                 /* actionlist */
                 switch(prodlist[k + 2])
                 {
                 case CONST:
                  actionlist[altentry] = prodtokenvalue[k + 2];
                  break;

                 case STRING:
                  actionlist[altentry] = -prodtokenvalue[k + 2]; /*-ve denotes string index at output*/
                  break;

                 default:
                  actionlist[altentry] = prodlist[k + 2];
                  break;
                 };

if((testprint & 0x2) != 0) printf("actionlist[altentry:%3d]: %3d\n",altentry,actionlist[altentry]);
                 /* sequencelist */

                 switch(prodlist[k + 3])
                 {
                 case CONST:
                  sequencelist[altentry] = prodtokenvalue[k + 3];
                  break;

                 case STRING:
                  sequencelist[altentry] = -prodtokenvalue[k + 3]; /*-ve denotes string index at output*/
                  break;
#if 0
                 case IDENT:
                  sequencelist[altentry] = symbol_value_4[prodlist[prodtokenvalue[k + 3]]];
                  if(symbol_value_4[prodlist[prodtokenvalue[k + 3]]] <= 0)
                    symbol_value_4[prodlist[prodtokenvalue[k + 3]]] = -altentry; /*continue  backward fixup chain*/
                  break;
#endif
		 case LINK:
                  sequencelist[altentry] = symbol_value_4[prodlist[prodtokenvalue[k + 3]]];
                  if(symbol_value_4[prodlist[prodtokenvalue[k + 3]]] <= 0)
                    symbol_value_4[prodlist[prodtokenvalue[k + 3]]] = -altentry; /*continue  backward fixup chain*/
		  break;

                 default:
		 printf("suspect token type: prodlist[k + 3]: prodlist[ %3d]: %3d\n",k + 3, prodlist[k + 3]);
                  sequencelist[altentry] = prodlist[k + 3];
                  break;
                 };

                  if(prevseqfixup > 0)
                   {  sequencelist[prevseqfixup] = altentry ;
if((testprint & 0x2) != 0)
 {
  printf("table entry B at %3d:\n",prevseqfixup);
 printf("sequencelistlink: %3d, at: %3d\n",sequencelist[prevseqfixup],prevseqfixup);
 printf("sequencelist[prevseqfixup:%3d]: %3d\n",prevseqfixup,sequencelist[prevseqfixup]);
 };
                   };
                 prevseqfixup = 0;
if((testprint & 0x2) != 0)
 {
  printf("table entry C at %3d:\n",altentry);
  printf("sequencelis[altentry:%3d]: %3d\n",altentry,sequencelist[altentry]);
 };



                 altentry++;
                 prodlist[j + 4]++;


                 }
                 else
                
                 {if (i < (prodlist[k + 1] - 1))
                 {/* not last token in sequence */
if((testprint & 0x2) != 0)
 {
  printf("not last token in sequence\n");
  printf("table entry D at %3d:\n",altentry);
 };

                 /* tokenlist*/
                 switch(prodlist[i])
                 {
                 case STRING:
                  tokenlist[altentry] = STRING;
                  tokenvaluelist[altentry] = prodtokenvalue[i];
                  break;
                 case CONST:
                  tokenlist[altentry] = CONST;
                  tokenvaluelist[altentry] = prodtokenvalue[i];
                  break;


                 case IDENT:
                  tokenlist[altentry] = symbol_value_3[prodlist[prodtokenvalue[i]]];
                  if(symbol_value_3[prodlist[prodtokenvalue[i]]] <= 0)
                    symbol_value_3[prodlist[prodtokenvalue[i]]] = -altentry; /*continue  backward fixup chain*/
                  break;
                 case LINK:
                  tokenlist[altentry] = symbol_value_3[prodlist[prodtokenvalue[i]]];
                  if(symbol_value_3[prodlist[prodtokenvalue[i]]] <= 0)
                    symbol_value_3[prodlist[prodtokenvalue[i]]] = -altentry; /*continue  backward fixup chain*/
                   else
                    tokenlist[altentry] = tokenlist[altentry] + NONTERMINAL;
                  break;

                 default:
                  tokenlist[altentry] = prodlist[i];
                  break;
                 };
if((testprint & 0x2) != 0) printf("tokenlist[altentry:%3d]: %3d\n",altentry,tokenlist[altentry]);
                 /* actionlist */
                  actionlist[altentry] = EMPTY;

if((testprint & 0x2) != 0) printf("actionlist[altentry:%3d]: %3d\n",altentry,actionlist[altentry]);
                 /* sequencelist */
                  if(prevseqfixup > 0)
                   {  sequencelist[prevseqfixup] = altentry ;
if((testprint & 0x2) != 0)
 {
  printf("table entry E at %3d:\n",prevseqfixup);
  printf("sequencelistlink: %3d, at: %3d\n",sequencelist[prevseqfixup],prevseqfixup);
  printf("sequencelist[prevseqfixup:%3d]: %3d\n",prevseqfixup,sequencelist[prevseqfixup]);
 };
                   };
                 prevseqfixup = altentry;
		 sequencelist[altentry] = EMPTY;
if((testprint & 0x2) != 0)
 {
  printf("table entry F at %3d:\n",altentry);
  printf("sequencelist[altentry:%3d]: %3d\n",altentry,sequencelist[altentry]);
 };

                 altentry++;
                 prodlist[j + 4]++;

/*
                  tokenlist[nextavailentry] = EXHAUSTED;
                  actionlist[nextavailentry] = EMPTY;
                  sequencelist[prevseqfixup] = EMPTY;

                 nextavailentry++;

*/
                 };
                 };




		     };





		  };/* generate alternate entries first*/


	        while(prodlist[k + 5] < prodlist[k + 1])
		{
                 prodlist[k + 5]++;

		 if((testprint & 0x2) != 0)
		  {
		   printf("loop2\n");
		   printf("prodlist[k + 1]: %4d\n",prodlist[k + 1]);
		   printf("prodlist[k + 5]: %4d\n",prodlist[k + 5]);
		  };

       	       i = prodlist[k + 5];
       	       if (i == (prodlist[k + 1] - 1))
	         {/* last token in sequence*/
if((testprint & 0x2) != 0)
 {
  printf("last token in sequence\n");
  printf("table entry G at %3d:\n",nextavailentry);
 };
		 /* tokenlist*/
		 switch(prodlist[i])
		 {
                 case STRING:
                  tokenlist[nextavailentry] = STRING;
                  tokenvaluelist[nextavailentry] = prodtokenvalue[i];
                  break;
                 case CONST:
                  tokenlist[nextavailentry] = CONST;
                  tokenvaluelist[nextavailentry] = prodtokenvalue[i];
                  break;

		 case IDENT:
		  tokenlist[nextavailentry] = symbol_value_3[prodlist[prodtokenvalue[i]]];
		  if(symbol_value_3[prodlist[prodtokenvalue[i]]] <= 0)
		    symbol_value_3[prodlist[prodtokenvalue[i]]] = -nextavailentry; /*continue  backward fixup chain*/
		  break;

                 case LINK:
                  tokenlist[nextavailentry] = symbol_value_3[prodlist[prodtokenvalue[i]]];
                  if(symbol_value_3[prodlist[prodtokenvalue[i]]] <= 0)
                    symbol_value_3[prodlist[prodtokenvalue[i]]] = -nextavailentry; /*continue  backward fixup chain*/
                   else
                    tokenlist[nextavailentry] = tokenlist[nextavailentry] + NONTERMINAL;
                  break;

		 default:
		  tokenlist[nextavailentry] = prodlist[i];
		  break;
		 };
if((testprint & 0x2) != 0) printf("tokenlist[nextavailentry:%3d]: %3d\n",nextavailentry,tokenlist[nextavailentry]);

		 /* actionlist */
                 switch(prodlist[k + 2])
                 {
                 case CONST:
		  actionlist[nextavailentry] = prodtokenvalue[k + 2];
		  break;
                  
                 case STRING:
                  actionlist[nextavailentry] = -prodtokenvalue[k + 2]; /*-ve denotes string index at output*/
                  break;

                 default:
                  actionlist[nextavailentry] = prodlist[k + 2];
                  break;
                 };

if((testprint & 0x2) != 0) printf("actionlist[nextavailentry:%3d]: %3d\n",nextavailentry,actionlist[nextavailentry]);

		 /* sequencelist */

                 switch(prodlist[k + 3])
                 {
                 case CONST:
                  sequencelist[nextavailentry] = prodtokenvalue[k + 3];
                  break;

                 case STRING:
                  sequencelist[nextavailentry] = -prodtokenvalue[k + 3]; /*-ve denotes string index at output*/
                  break;
#if 0
                 case IDENT:
                  sequencelist[nextavailentry] = symbol_value_4[prodlist[prodtokenvalue[k + 3]]];
                  if(symbol_value_4[prodlist[prodtokenvalue[k + 3]]] <= 0)
                    symbol_value_4[prodlist[prodtokenvalue[k + 3]]] = -nextavailentry; /*continue  backward fixup chain*/
                  break;
#endif
                 case LINK:
                  sequencelist[nextavailentry] = symbol_value_4[prodlist[prodtokenvalue[k + 3]]];
                  if(symbol_value_4[prodlist[prodtokenvalue[k + 3]]] <= 0)
                    symbol_value_4[prodlist[prodtokenvalue[k + 3]]] = -nextavailentry; /*continue  backward fixup chain*/
                  break;



                 default:
                  sequencelist[nextavailentry] = prodlist[k + 3];
                  break;
                 };

if((testprint & 0x2) != 0) printf("sequencelist[nextavailentry:%3d]: %3d\n",nextavailentry,sequencelist[nextavailentry]);
                  if(prevseqfixup > 0)
                   {  sequencelist[prevseqfixup] = nextavailentry ;
if((testprint & 0x2) != 0)
 {
   printf("table entry H at %3d:\n",prevseqfixup);
   printf("sequencelistlink: %3d, at: %3d\n",sequencelist[prevseqfixup],prevseqfixup);
   printf("sequencelist[prevseqfixup:%3d]: %3d\n",prevseqfixup,sequencelist[prevseqfixup]);
 };
                   };
                 prevseqfixup = 0;

		 nextavailentry++;
		  
                  tokenlist[nextavailentry] = EXHAUSTED;
                  actionlist[nextavailentry] = EMPTY;
                  sequencelist[nextavailentry] = EMPTY;


if((testprint & 0x2) != 0)
 {
   printf("table entry HA at %3d:\n",nextavailentry);

   printf("tokenlist[nextavailentry:%3d]: %3d\n",nextavailentry,tokenlist[nextavailentry]);
   printf("actionlist[nextavailentry:%3d]: %3d\n",nextavailentry,actionlist[nextavailentry]);
   printf("sequencelist[nextavailentry:%3d]: %3d\n",nextavailentry,sequencelist[nextavailentry]);
 };

                 nextavailentry++;
		 
		 }
		 else
		 {if (i < (prodlist[k + 1] - 1))
		 {/* not last token in sequence */
if((testprint & 0x2) != 0)
 {
   printf("not last token in sequence\n");
   printf("table entry I at %3d:\n",nextavailentry);
 };

                 /* tokenlist*/
                 switch(prodlist[i])
                 {
                 case STRING:
                  tokenlist[nextavailentry] = STRING;
                  tokenvaluelist[nextavailentry] = prodtokenvalue[i];
                  break;
                 case CONST:
                  tokenlist[nextavailentry] = CONST;
                  tokenvaluelist[nextavailentry] = prodtokenvalue[i];
                  break;


                 case IDENT:
                  tokenlist[nextavailentry] = symbol_value_3[prodlist[prodtokenvalue[i]]];
                  if(symbol_value_3[prodlist[prodtokenvalue[i]]] <= 0)
                    symbol_value_3[prodlist[prodtokenvalue[i]]] = -nextavailentry; /*continue  backward fixup chain*/
                  break;

                 case LINK:
                  tokenlist[nextavailentry] = symbol_value_3[prodlist[prodtokenvalue[i]]];
                  if(symbol_value_3[prodlist[prodtokenvalue[i]]] <= 0)
                    symbol_value_3[prodlist[prodtokenvalue[i]]] = -nextavailentry; /*continue  backward fixup chain*/
                   else
                    tokenlist[nextavailentry] = tokenlist[nextavailentry] + NONTERMINAL;
                  break;

                 default:
                  tokenlist[nextavailentry] = prodlist[i];
                  break;
                 };
if((testprint & 0x2) != 0) printf("tokenlist[nextavailentry:%3d]: %3d\n",nextavailentry,tokenlist[nextavailentry]);

                 /* actionlist */
                  actionlist[nextavailentry] = EMPTY;
if((testprint & 0x2) != 0) printf("actionlist[nextavailentry:%3d]: %3d\n",nextavailentry,actionlist[nextavailentry]);


                 /* sequencelist */
                  if(prevseqfixup > 0)
                     {
		      sequencelist[prevseqfixup] = nextavailentry ;
		      if((testprint & 0x2) != 0) printf("table entry J at %3d:\n",prevseqfixup);

		      if((testprint & 0x2) != 0) printf("sequencelist: %3d\n",sequencelist[prevseqfixup]);
		      };
                  prevseqfixup = nextavailentry ;

		 nextavailentry++;

                  tokenlist[nextavailentry] = EXHAUSTED;
                  actionlist[nextavailentry] = EMPTY;
                  sequencelist[nextavailentry] = EMPTY;


if((testprint & 0x2) != 0)
 {
   printf("table entry K at %3d:\n",nextavailentry);

   printf("tokenlist[nextavailentry:%3d]: %3d\n",nextavailentry,tokenlist[nextavailentry]);
   printf("actionlist[nextavailentry:%3d]: %3d\n",nextavailentry,actionlist[nextavailentry]);
   printf("sequencelist[nextavailentry:%3d]: %3d\n",nextavailentry,sequencelist[nextavailentry]);
 };

                  sequencelist[prevseqfixup] = EMPTY;

                 nextavailentry++;


		 };
		 };

		  /* prodlist[k + 5]++; once is enough*/


               };/* loop2 */

               if((testprint & 0x2) != 0) printf("end of loop2-- j: %3d  k: %3d\n",j,k);

          };
	  k = prodlist[k + 1];
        }; /* loop1 */
          if(tokenlist[prodlist[j + 4]] == 0)
           {
             altentry = prodlist[j + 4];
             tokenlist[altentry] = EXHAUSTED;
             actionlist[altentry] = EMPTY;
             sequencelist[altentry] = EMPTY;

if((testprint & 0x2) != 0)
  {
    printf("table entry L at %3d:\n",altentry);
    printf("tokenlist[altentry:%3d]: %3d\n",altentry,tokenlist[altentry]);
    printf("actionlist[altentry:%3d]: %3d\n",altentry,actionlist[altentry]);
    printf("sequencelist[altentry:%3d]: %3d\n",altentry,sequencelist[altentry]);
  };
           };
               if((testprint & 0x2) != 0) printf("end of loop1-- j: %3d  k: %3d\n",j,k);

      k = curprodhead;
      while ((prodlist[k] > 0) && (prodlist[curprodhead] == prodlist[k])) k =prodlist[k + 1];

      curprodhead = k;
               if((testprint & 0x2) != 0) printf("bottom of main loop-- curprodhead: %3d, j: %3d,  k: %3d\n",curprodhead,j,k);
if((testprint & 0x2) != 0) {
printf("progress of output tables:\n");

for(i=0;i<nextavailentry;i++)
 {printf(" %4d ",i);

  {/* tokenlist */
   if(tokenlist[i] > 0)
     {if (tokenlist[i] <= NONTERMINAL)
       printf("|   %3d         ",tokenlist[i] );
      else
       printf("|%3d+NONTERMINAL",tokenlist[i] - NONTERMINAL);
     }
     else
     if (tokenlist[i] < 0)
       {
printf("|");
       for(j = literal_string_list_index[ -tokenlist[i] ],
       k=0; (literal_string_list[j] !=0) && (k < 15);k++,j++)printf("%c",literal_string_list[j]);
       for(;k < 15;k++)printf(" ");

       }
       else
printf("|   %3d         ",tokenlist[i] );

/*
 *  * if (tokenlist[i] == EMPTY)
 *         printf("|EMPTY    ");
 *                else
 *                       printf("|EXHAUSTED");
 *                              */
  };

  {/* actionlist */

     if (actionlist[i] < (-1))
       {
printf("|");
       for(j = literal_string_list_index[ -actionlist[i]],
       k=0; (literal_string_list[j] !=0) && (k < 12);k++,j++)printf("%c",literal_string_list[j]);
       for(;k < 12;k++)printf(" ");

       }
       else
printf("|   %3d        ",actionlist[i] );

  };

  {/* sequencelist */
          if (sequencelist[i] == EMPTY)
           printf("|EMPTY   \n ");
          else
           printf("|   %3d  \n ",sequencelist[i] );


  };
 };
printf("\n\n");



}
    }; /*main loop*/

   };

/* finished generating parse tables */

/* report any undefined symbols */

   printf("1\n\n\n");

        for(i=first_identifier_index;i<next_symbol_index;i++)
          {
             k = symbol_string_list_index[i];
             if ((symbol_value_2[i] <= 0) || (symbol_value_3[i] < 0) || (symbol_value_4[i] < 0))
               {
                printf("undefined identifier in table at entry %3d: ",i);
                for(j=k; symbol_string_list[j] !=0;j++)printf("%c",symbol_string_list[j]);
                printf("  %4d  %4d  %4d  %4d",symbol_value_1[i],
                    symbol_value_2[i],
                    symbol_value_3[i],
                    symbol_value_4[i] );

                printf("\n");
               };
        };

   printf("2\n\n\n");


/* output various tables */

if((testprint & 0x2) != 0) {printf("output1\n");
for(i=0;i<nextavailentry;i++)
 {printf(" %4d ",i);

  {/* tokenlist */
   if(tokenlist[i] >= 0)
     {if (tokenlist[i] <= NONTERMINAL)
       {
       /*printf("|   %3d         ",tokenlist[i] );*/
       printf("|");
       if (tokenlist[i] == CONST) scanned_constant_value = tokenvaluelist[i];
       else if (tokenlist[i] == STRING) scanned_string_index = tokenvaluelist[i];

       k = token_dump(tokenlist[i] );
       for(;k < 15;k++)printf(" ");
       }
      else
       printf("|%3d+NONTERMINAL",tokenlist[i] - NONTERMINAL);
     }
     else
     if (tokenlist[i] < 0)
       {
       if (tokenlist[i] == EMPTY)    printf("|EMPTY          ");
       else
       if (tokenlist[i] == EXHAUSTED)printf("|EXHAUSTED      ");
       else
       {
       printf("|");
       for(j = literal_string_list_index[ -tokenlist[i] ],
       k=0; (literal_string_list[j] !=0) && (k < 15);k++,j++)printf("%c",literal_string_list[j]);
       for(;k < 15;k++)printf(" ");
       };

       };


  };

  {/* actionlist */

     if (actionlist[i] < EXHAUSTED)
       {
printf("|");
       for(j = literal_string_list_index[ -actionlist[i]],
       k=0; (literal_string_list[j] !=0) && (k < 13);k++,j++)printf("%c",literal_string_list[j]);
       for(;k < 13;k++)printf(" ");

       }
       else
       if (actionlist[i] == EMPTY)    printf("|EMPTY          ");
       else
       if (actionlist[i] == EXHAUSTED)printf("|EXHAUSTED      ");
       else
       printf("|   %3d        ",actionlist[i] );

  };

  {/* sequencelist */
          if (sequencelist[i] == EMPTY)
           printf("|EMPTY   \n ");
          else
           if(sequencelist[i] < 0)
             {
       for(j = literal_string_list_index[ -sequencelist[i]],
       k=0; (literal_string_list[j] !=0) && (k < 13);k++,j++)printf("%c",literal_string_list[j]);
       printf(",\n");
             }
           else
           printf("|   %3d  \n ",sequencelist[i] );


  };
 };
symbol_table_dump(13);
};

{
printf("#endif\n\n");
/* formatted tables to paste into code */
/*
 * int parse_table_token[] = x
 * int parse_table_action[] = x
 * int parse_table_control[] = x
 */
printf("\n\n/* generated tables */\n");
printf("\n\nint parse_table_token[] = {\n");
for(i=0;i<nextavailentry;i++)
  {/* tokenlist */
   if(tokenlist[i] >= 0)
     {if (tokenlist[i] <= NONTERMINAL)
       {
       
       if (tokenlist[i] == CONST) printf("      %3d,\n",tokenvaluelist[i]);
       else 
        {
	 if (tokenlist[i] == STRING)
         {
	 printf("      ");
       for(j = literal_string_list_index[ tokenvaluelist[i] ],
       k=0; (literal_string_list[j] !=0) && (k < 15);k++,j++)printf("%c",literal_string_list[j]);
       printf(",\n");
         }
        else
          printf("      %3d,\n",tokenlist[i]);
        };
       }
      else
       printf("      %3d+NONTERMINAL,\n",tokenlist[i] - NONTERMINAL);
     }
     else
       {
       if (tokenlist[i] == EMPTY)    printf("      EMPTY,\n");
       else
        {
         if (tokenlist[i] == EXHAUSTED)
	  printf("      EXHAUSTED,\n");
	   else
          printf("      %3d,\n",tokenlist[i]);
	};   
       };
  };
  printf("     };\n");

printf("\n\nint parse_table_action[] = {\n");
for(i=0;i<nextavailentry;i++)
  {
/*printf("actionlist[%3d]: %3d\n",i,actionlist[i]);*/
     if (actionlist[i] < EXHAUSTED)
       {
        printf("      ");
       for(j = literal_string_list_index[ -actionlist[i]],
       k=0; (literal_string_list[j] !=0) && (k < 13);k++,j++)printf("%c",literal_string_list[j]);
       printf(",\n");

       }
       else
       if (actionlist[i] == EMPTY)    printf("      EMPTY,\n");
       else
       if (actionlist[i] == EXHAUSTED)printf("      EXHAUSTED,\n");
       else
       printf("      %3d,\n",actionlist[i] );

  };
  printf("     };\n");
 

printf("\n\nint parse_table_control[] = {\n");
for(i=0;i<nextavailentry;i++)
  {/* sequencelist */
/*printf("sequencelist[%3d]: %3d\n",i,sequencelist[i]);*/
          if (sequencelist[i] == EMPTY)
           printf("    EMPTY,\n");
          else
           if(sequencelist[i] < 0)
             {
        printf("    ");
	for(j = literal_string_list_index[ -sequencelist[i]],
       k=0; (literal_string_list[j] !=0) && (k < 13);k++,j++)printf("%c",literal_string_list[j]);
       printf(",\n");
             }
           else
           printf("    %3d,\n",sequencelist[i] );
  };
  printf("     };\n\n\n");


printf("#if 0\n\n");

};
  break;

case 2:
  if((testprint & 0x2) != 0) printf("cleanup end of production\n");
/*  prevprodhead = curprodhead; */
  prodlist[curprodhead + 1] = curprodindx + 1;
  prodlist[curprodindx + 1] = 0;
  break;


case 3:
  if((testprint & 0x2) != 0) 
   {
    printf("start next production; check if alternate to prior production\n");
    token_dump(current_token);
    printf("\n\n");
   };
  if((curprodindx + 8) >= prodlistlimit){printf("production list is full at line %5d, can't proceed\n",line_no);return;};
  curprodindx = curprodindx + 1;
  curprodhead = curprodindx;
  /*if (prevprodhead > 0) prodlist[prevprodhead + 1] = curprodhead;*/
  if (symbol_value_2[scanned_identifier_index] == 0)
   {/* first definition here*/
  if((testprint & 0x2) != 0) printf("first definition here\n");
    symbol_value_2[scanned_identifier_index] = curprodhead ;
   };
  if (symbol_value_2[scanned_identifier_index] < 0)
   {/*fixup forward references here*/
     if((testprint & 0x2) != 0) printf("fixup forward references here\n");
     for(i=symbol_value_2[scanned_identifier_index];i<0;)
        {
	 j = prodtokenvalue[-i];
     if((testprint & 0x2) != 0) printf("fixup reference prodtokenvalue[%3d] to be %3d\n",-i,curprodhead);
	 prodtokenvalue[-i] = curprodhead ;
	 i = j;
	};
    symbol_value_2[scanned_identifier_index] = curprodhead ;
   }
   prodlist[curprodhead] = scanned_identifier_index;
   /* space for fwd link, action, and sequence */
   curprodindx = curprodindx + 5;

  break;


case 4:
   if((testprint & 0x2) != 0)
    {
     printf("add token to data table\n");
     token_dump(current_token);
     printf("\n\n");
    };

  if((curprodindx + 2) >= prodlistlimit){printf("production list is full at line %5d, can't proceed\n",line_no);return;};

   curprodindx = curprodindx + 1;

   if (current_token == CONST) /* numeric constant is used directly*/
     {
      prodlist[curprodindx] = CONST;
      prodtokenvalue[curprodindx] = scanned_constant_value;
     } 
   else
      if (current_token == STRING)
      {/* string literal */
       prodlist[curprodindx] = STRING;
       prodtokenvalue[curprodindx] = scanned_string_index;
      }
   else
   if (current_token == IDENT)
     {/* identifier */
     prodlist[curprodindx] = LINK;
     prodtokenvalue[curprodindx] = symbol_value_2[scanned_identifier_index];
      if (symbol_value_2[scanned_identifier_index] <= 0)
        {/*not defined yet-- add fixup link */
	  symbol_value_2[scanned_identifier_index] = -curprodindx;
	};
     }
   else
    prodlist[curprodindx] = current_token;


     
  break;


case 5:
  if((testprint & 0x2) != 0)
   {
     printf("add action identifier to data table\n");
     token_dump(current_token);
     printf("\n\n");
   };

   if (current_token == CONST) /* numeric constant is used directly*/
    {
     prodlist[curprodhead + 2] = CONST;
     prodtokenvalue[curprodhead + 2] = scanned_constant_value;
    }
   else
   if (current_token == IDENT)
     {/* identifier  is interned in string literal list*/
       prodlist[curprodhead + 2] = STRING;
       prodtokenvalue[curprodhead + 2] = string_table_lookup(literal_index_limit, &next_literal_index, literal_string_list_limit,
                                           literal_string_list_index, literal_sorted_order, literal_string_list,
                                           &next_literal_string_list, scanned_identifier, scanned_identifier_length);


     }
     else
     if (current_token == STRING)
      {
      prodlist[curprodhead + 2] = STRING;
      prodtokenvalue[curprodhead + 2] = scanned_string_index;

      }
     else
      {
      printf("can\'t have this token type in action field: ");
      token_dump(current_token);
      printf("\n");
      }

      break;


case 6:
  if((testprint & 0x2) != 0)
   {
    printf("add sequence identifier to data table\n");
    token_dump(current_token);
    printf("\n\n");
   };


   if (current_token == CONST) /* numeric constant is used directly*/
    {
     prodlist[curprodhead + 3] = CONST;
     prodtokenvalue[curprodhead + 3] = scanned_constant_value;
    }
   else
   if (current_token == IDENT)
     {/* identifier */
      prodlist[curprodhead + 3] = LINK;
      prodtokenvalue[curprodhead + 3] = symbol_value_2[scanned_identifier_index];
      if (symbol_value_2[scanned_identifier_index] <= 0)
        {/*not defined yet-- add fixup link */
          symbol_value_2[scanned_identifier_index] = -(curprodhead + 3);
        };
     }
   else
   if (current_token == STRING)
     {/*  string literal */
      prodlist[curprodhead + 3] = STRING;
      prodtokenvalue[curprodhead + 3] = scanned_string_index;

     }; 

   break;


default:
      return;
 };
}


/**************************************************************************************/

/* parser */
/* Slimmick's version of Conway's parser: */




int conway_parser()
{
codegen_init();
j = 1;
scan_index = j;
current_token = scan();
if(current_token == -1) return 1;
 {
 if(takepath(1) == TRUE)
  {/*if(testprint != 0)*/printf("legal at line number: %4d\n\n",line_no);}
 else
  {/*if(testprint != 0)*/printf("illegal at line number: %4d\n\n",line_no);};
 };
return (0);
}

void semantic_action_orig(int i)
{
printf("******** semantic action %3d\n",i);
}


int sym(int i)
{
if(i == scan_index) 
  {
    if(testprint & 0x1 != 0)
     {
       printf("index:%3d, scan_index:%3d, current_token:%3d is: ",i, scan_index, current_token);
       token_dump(current_token);
       printf("\n");
     };
  return current_token;}
 else
  if (i > scan_index)
  {
  current_token = scan();
  current_token_value = 0;
  if (current_token == CONST) current_token_value = scanned_constant_value;
  if (current_token == IDENT) current_token_value = scanned_identifier_index;
  if(testprint & 0x1 != 0)
   {
     printf("index:%3d, scan_index:%3d, current_token:%3d is: ",i, scan_index, current_token);
     token_dump(current_token); printf("\n");
   };
  scan_index = i;
  return current_token;};

 printf("can't backup scanner in line no. %4d\n",line_no);
 if(testprint & 0x1 != 0)
   {
     printf("index:%3d, scan_index:%3d, current_token:%3d is: ",i, scan_index, current_token);
     token_dump(current_token); 
     printf("\n");
   };
 return current_token;
}

void prodlabel(int i)
{
int j;
if (i <= 0) return;
#ifndef PRODLABEL
printf("\n");
#else
printf(" production label: %s \n",prod_label[i]);
#endif

}


int terminal(int i){return ( (i < NONTERMINAL) && (i > 0) );}
int nonterminal(int i){return (i >= NONTERMINAL);}

int takepath_orig(int k)
{
/*recursive original version*/
int jsave, i;
printf("parsing diagram rooted at node %3d\n",k);
 i = k;

 for(;(i != EMPTY) && (parse_table_token[i] != EXHAUSTED);)
   {
   printf("checking token %3d at node %3d\n",parse_table_token[i], i);
    if(terminal(parse_table_token[i]))
     {
     printf("looking for "); token_print(parse_table_token[i]); printf("\n");
       if(parse_table_token[i] == sym(j))
        {
	printf("terminal token matched at node %3d\n",i);
	semantic_action(parse_table_action[i]);
         j = j+1;
	 i = parse_table_control[i];
	}
	else
	{printf("terminal token mismatched at node %2d\n",i);
	i = i+1;};

     } 
     else
     {
       if(nonterminal(parse_table_token[i]))
       {printf("checking nonterminal token %3d (node %3d) from node %3d\n",parse_table_token[i], parse_table_token[i] - NONTERMINAL, i);
         jsave = j;
	 if(takepath(parse_table_token[i] - NONTERMINAL))
	   {printf("accepted nonterminal token %3d (node %3d) from node %3d\n",parse_table_token[i], parse_table_token[i] - NONTERMINAL,i);
	   semantic_action(parse_table_action[i]);
	   i = parse_table_control[i];}
	   else
	   {printf("rejected nonterminal token %3d (node %3d) from node %3d\n",parse_table_token[i], parse_table_token[i] - NONTERMINAL,i);
            j = jsave;
	    i = i+1;
	   }
       }
       else
       {
        if(parse_table_token[i] == EMPTY)
	  {printf("empty token accepted at node %3d\n",i);semantic_action(parse_table_action[i]);i = parse_table_control[i];}
	 else
	  {printf("error1 at node %3d\n", i);
	  return(FALSE);};
       };
     }
   };

   if(i == EMPTY)
    return(TRUE);
    else
     {
      if(parse_table_control[i] == EMPTY /*EXHAUSTED*/)
       {printf("error2a at node %3d\n", i);
       return(FALSE);}
       else
        {/* printf("error2b at node %3d\n", i); */
	 return (FALSE);};
     }
}



int takepath(int k)
{
/*version using explicit stack instead of recursion*/
int parse_table_stack[1000], token_stack[1000];
int stack_limit, stack_index, recurse, return_value;
int i;

stack_limit = sizeof(parse_table_stack)/sizeof(int);
stack_index = 0;
recurse = 0;

parse_table_stack[0] = 0;
token_stack[0] = -1;

i = k;

for (;;)
{
  if(testprint & 0x1 != 0)
   {
     printf("parsing diagram rooted at node %3d",i);
     prodlabel(i);
     if (i<=0)printf("\n");
   };


 for(;(i != EMPTY) && (parse_table_token[i] != EXHAUSTED) && (recurse == 0);)
   {
   if(testprint & 0x1  != 0)
    {
      printf("checking token %3d at node %3d",parse_table_token[i], i);
      prodlabel(i);
    };

    if(terminal(parse_table_token[i]))
     {
     if(testprint & 0x1  != 0)
      {
        printf("looking for ");
	token_print(parse_table_token[i]);
	printf("\n");
      };

       if(parse_table_token[i] == sym(j))
        {
        if(testprint & 0x1  != 0)
	 {
	  printf("terminal token matched at node %3d",i);
	  prodlabel(i);
	 };

        semantic_action(parse_table_action[i]);
         j = j+1;
         i = parse_table_control[i];
        }
        else
        {
	if(testprint & 0x1  != 0)
	 {
	   printf("terminal token mismatched at node %3d",i);
	   prodlabel(i);
	 };

        i = i+1;
	};

     }
     else
     {
       if(nonterminal(parse_table_token[i]))
       {
	 recurse = 1;
       }
       else
       {
        if(parse_table_token[i] == EMPTY)
          {
	  if(testprint & 0x1  != 0)
	   {
	     printf("empty token accepted at node %3d",i);
	     prodlabel(i);
	   };

	  semantic_action(parse_table_action[i]);
	  i = parse_table_control[i];
	  }
         else
          {
	  printf("error1 at node %3d", i);
	  prodlabel(i);
          return(FALSE);
	  };
       };
     };
   };
  if(recurse == 0)
  {
   if(i == EMPTY)
    return_value = TRUE;
    else
     {
#if 0     
      if(parse_table_control[i] == EMPTY /*EXHAUSTED*/)
       {printf("error2 at node %3d", i);
       prodlabel(i);
       return(FALSE);}
       else
#endif
        {
         return_value = FALSE;
	 };
     };
     if (stack_index > 0)
      {
      stack_index--;
  if(testprint & 0x1  != 0) printf("parser stack has depth %4d\n",stack_index);
      if (return_value == TRUE)
        {
	if(testprint & 0x1  != 0)
	 {
	  printf("accepted nonterminal token %3d (node %3d) from node %3d",parse_table_token[parse_table_stack[stack_index]],
	                parse_table_token[parse_table_stack[stack_index]] - NONTERMINAL,parse_table_stack[stack_index]);
	  prodlabel(parse_table_stack[stack_index]);
	 };
	semantic_action(parse_table_action[parse_table_stack[stack_index] ]);
	i = parse_table_control[parse_table_stack[stack_index] ];
	}
	else
	{
	if(testprint & 0x1  != 0)
	 {
	  printf("rejected nonterminal token %3d (node %3d) from node %3d",parse_table_token[parse_table_stack[stack_index]], parse_table_token[parse_table_stack[stack_index]] - NONTERMINAL,parse_table_stack[stack_index]);
	  prodlabel(parse_table_stack[stack_index]);
	  };

	j = token_stack[stack_index];
	i = parse_table_stack[stack_index] + 1;
	};

     }
     else
     return(return_value);
   }
   else
   {
          if(testprint & 0x1  != 0)
	   {
	    printf("checking nonterminal token %3d (node %3d) from node %3d",parse_table_token[i],
                                           parse_table_token[i] - NONTERMINAL, i);
	    prodlabel(i);
	   };

          token_stack[stack_index] = j;
          parse_table_stack[stack_index] = i;
          i = parse_table_token[i] - NONTERMINAL;
	  if (stack_index >= stack_limit){printf("parser stack is full at line %5d, can't continue\n",line_no); return FALSE;};
          stack_index++;
	  if(testprint & 0x1  != 0) printf("parser stack has depth %4d\n",stack_index);
   recurse = 0;
   };

  };

}


